require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SIGNAL_H)) {
    if(!defined (&__need_sig_atomic_t)  && !defined (&__need_sigset_t)) {
	eval 'sub _SIGNAL_H () {1;}' unless defined(&_SIGNAL_H);
    }
    require 'features.ph';
    require 'bits/sigset.ph';
    if(defined (&__need_sig_atomic_t) || defined (&_SIGNAL_H)) {
	unless(defined(&__sig_atomic_t_defined)) {
	    eval 'sub __sig_atomic_t_defined () {1;}' unless defined(&__sig_atomic_t_defined);
	}
	undef(&__need_sig_atomic_t) if defined(&__need_sig_atomic_t);
    }
    if(defined (&__need_sigset_t) || (defined (&_SIGNAL_H)  && defined (&__USE_POSIX))) {
	unless(defined(&__sigset_t_defined)) {
	    eval 'sub __sigset_t_defined () {1;}' unless defined(&__sigset_t_defined);
	}
	undef(&__need_sigset_t) if defined(&__need_sigset_t);
    }
    if(defined(&_SIGNAL_H)) {
	require 'bits/types.ph';
	require 'bits/signum.ph';
	eval 'sub SIG_ERR () {(( &__sighandler_t) -1);}' unless defined(&SIG_ERR);
	eval 'sub SIG_DFL () {(( &__sighandler_t) 0);}' unless defined(&SIG_DFL);
	eval 'sub SIG_IGN () {(( &__sighandler_t) 1);}' unless defined(&SIG_IGN);
	if(defined(&__USE_UNIX98)) {
	    eval 'sub SIG_HOLD () {(( &__sighandler_t) 2);}' unless defined(&SIG_HOLD);
	}
	unless(defined(&_NSIG)) {
	    eval 'sub _NSIG () {65;}' unless defined(&_NSIG);
	}
	if(defined(&__USE_MISC)) {
	    eval 'sub NSIG () { &_NSIG;}' unless defined(&NSIG);
	}
	eval 'sub SIGRTMIN () {( &__libc_current_sigrtmin());}' unless defined(&SIGRTMIN);
	eval 'sub SIGRTMAX () {( &__libc_current_sigrtmax());}' unless defined(&SIGRTMAX);
	unless(defined(&__SIGRTMIN)) {
	    eval 'sub __SIGRTMIN () {32;}' unless defined(&__SIGRTMIN);
	}
	eval 'sub __SIGRTMAX () {( &_NSIG - 1);}' unless defined(&__SIGRTMAX);
	if(defined (&__USE_XOPEN) || defined (&__USE_XOPEN2K)) {
	    unless(defined(&__pid_t_defined)) {
		eval 'sub __pid_t_defined () {1;}' unless defined(&__pid_t_defined);
	    }
	}
	if(defined(&__USE_XOPEN)) {
	    unless(defined(&__uid_t_defined)) {
		eval 'sub __uid_t_defined () {1;}' unless defined(&__uid_t_defined);
	    }
	}
	if(defined (&__USE_POSIX199309)  && defined (&__UCLIBC_HAS_REALTIME__)) {
	    eval 'sub __need_timespec () {1;}' unless defined(&__need_timespec);
	    require 'time.ph';
	}
	if(defined (&__USE_POSIX199309) || defined (&__USE_XOPEN_EXTENDED)) {
	    require 'bits/siginfo.ph';
	}
	if(defined (&__USE_XOPEN)  && defined (&__UCLIBC_SUSV3_LEGACY__)) {
	}
	if(defined(&__USE_POSIX)) {
	}
	if(defined (&__USE_BSD) || defined (&__USE_XOPEN_EXTENDED)) {
	}
	if(0) {
	}
	if(defined (&__USE_MISC) || defined (&__USE_XOPEN2K8)) {
	}
	if(0) {
	}
	if(defined(&__FAVOR_BSD)) {
	} else {
	    if(defined(&__USE_XOPEN)) {
	    }
	}
	if(0) {
	    eval 'sub sigmask {
	        my($sig) = @_;
    		eval q( &__sigmask($sig));
	    }' unless defined(&sigmask);
	}
	if(defined(&__USE_GNU)) {
	}
	if(defined(&__USE_BSD)) {
	}
	if(defined(&__USE_POSIX)) {
	    if(defined(&__USE_GNU)) {
	    }
	    require 'bits/sigaction.ph';
	    if(defined (&__USE_POSIX199309)  && defined (&__UCLIBC_HAS_REALTIME__)) {
	    }
	}
	if(defined(&__USE_BSD)) {
	    eval 'sub _sys_siglist () { &sys_siglist;}' unless defined(&_sys_siglist);
	    eval 'sub sv_onstack () { &sv_flags;}' unless defined(&sv_onstack);
	    eval 'sub SV_ONSTACK () {(1<< 0);}' unless defined(&SV_ONSTACK);
	    eval 'sub SV_INTERRUPT () {(1<< 1);}' unless defined(&SV_INTERRUPT);
	    eval 'sub SV_RESETHAND () {(1<< 2);}' unless defined(&SV_RESETHAND);
	    if(0) {
	    }
	    require 'bits/sigcontext.ph';
	    if(0) {
	    }
	}
	if(defined (&__USE_BSD) || defined (&__USE_XOPEN_EXTENDED)) {
	    eval 'sub __need_size_t () {1;}' unless defined(&__need_size_t);
	    require 'stddef.ph';
	    require 'bits/sigstack.ph';
	    if(defined(&__USE_XOPEN)) {
		require 'sys/ucontext.ph';
	    }
	    if(0) {
	    }
	}
	if(defined (&__USE_XOPEN_EXTENDED)  && defined (&__UCLIBC_HAS_OBSOLETE_BSD_SIGNAL__)) {
	}
	if(defined (&__UCLIBC_HAS_THREADS__)  && (defined (&__USE_POSIX199506) || defined (&__USE_UNIX98))) {
	    require 'bits/pthreadtypes.ph';
	    require 'bits/sigthread.ph';
	}
    }
}
1;
