require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BITS_SYSNUM_H)) {
    eval 'sub _BITS_SYSNUM_H () {1;}' unless defined(&_BITS_SYSNUM_H);
    unless(defined(&_SYSCALL_H)) {
	die("Never use <bits/sysnum.h> directly; include <sys/syscall.h> instead.");
    }
    undef(&__NR_OABI_SYSCALL_BASE) if defined(&__NR_OABI_SYSCALL_BASE);
    eval 'sub __NR_OABI_SYSCALL_BASE () {0x900000;}' unless defined(&__NR_OABI_SYSCALL_BASE);
    eval 'sub SYS_OABI_SYSCALL_BASE () { &__NR_OABI_SYSCALL_BASE;}' unless defined(&SYS_OABI_SYSCALL_BASE);
    undef(&__NR_SYSCALL_BASE) if defined(&__NR_SYSCALL_BASE);
    eval 'sub __NR_SYSCALL_BASE () {0;}' unless defined(&__NR_SYSCALL_BASE);
    eval 'sub SYS_SYSCALL_BASE () { &__NR_SYSCALL_BASE;}' unless defined(&SYS_SYSCALL_BASE);
    undef(&__NR_restart_syscall) if defined(&__NR_restart_syscall);
    eval 'sub __NR_restart_syscall () {(0+ 0);}' unless defined(&__NR_restart_syscall);
    eval 'sub SYS_restart_syscall () { &__NR_restart_syscall;}' unless defined(&SYS_restart_syscall);
    undef(&__NR_exit) if defined(&__NR_exit);
    eval 'sub __NR_exit () {(0+ 1);}' unless defined(&__NR_exit);
    eval 'sub SYS_exit () { &__NR_exit;}' unless defined(&SYS_exit);
    undef(&__NR_fork) if defined(&__NR_fork);
    eval 'sub __NR_fork () {(0+ 2);}' unless defined(&__NR_fork);
    eval 'sub SYS_fork () { &__NR_fork;}' unless defined(&SYS_fork);
    undef(&__NR_read) if defined(&__NR_read);
    eval 'sub __NR_read () {(0+ 3);}' unless defined(&__NR_read);
    eval 'sub SYS_read () { &__NR_read;}' unless defined(&SYS_read);
    undef(&__NR_write) if defined(&__NR_write);
    eval 'sub __NR_write () {(0+ 4);}' unless defined(&__NR_write);
    eval 'sub SYS_write () { &__NR_write;}' unless defined(&SYS_write);
    undef(&__NR_open) if defined(&__NR_open);
    eval 'sub __NR_open () {(0+ 5);}' unless defined(&__NR_open);
    eval 'sub SYS_open () { &__NR_open;}' unless defined(&SYS_open);
    undef(&__NR_close) if defined(&__NR_close);
    eval 'sub __NR_close () {(0+ 6);}' unless defined(&__NR_close);
    eval 'sub SYS_close () { &__NR_close;}' unless defined(&SYS_close);
    undef(&__NR_creat) if defined(&__NR_creat);
    eval 'sub __NR_creat () {(0+ 8);}' unless defined(&__NR_creat);
    eval 'sub SYS_creat () { &__NR_creat;}' unless defined(&SYS_creat);
    undef(&__NR_link) if defined(&__NR_link);
    eval 'sub __NR_link () {(0+ 9);}' unless defined(&__NR_link);
    eval 'sub SYS_link () { &__NR_link;}' unless defined(&SYS_link);
    undef(&__NR_unlink) if defined(&__NR_unlink);
    eval 'sub __NR_unlink () {(0+ 10);}' unless defined(&__NR_unlink);
    eval 'sub SYS_unlink () { &__NR_unlink;}' unless defined(&SYS_unlink);
    undef(&__NR_execve) if defined(&__NR_execve);
    eval 'sub __NR_execve () {(0+ 11);}' unless defined(&__NR_execve);
    eval 'sub SYS_execve () { &__NR_execve;}' unless defined(&SYS_execve);
    undef(&__NR_chdir) if defined(&__NR_chdir);
    eval 'sub __NR_chdir () {(0+ 12);}' unless defined(&__NR_chdir);
    eval 'sub SYS_chdir () { &__NR_chdir;}' unless defined(&SYS_chdir);
    undef(&__NR_time) if defined(&__NR_time);
    eval 'sub SYS_time () { &__NR_time;}' unless defined(&SYS_time);
    undef(&__NR_mknod) if defined(&__NR_mknod);
    eval 'sub __NR_mknod () {(0+ 14);}' unless defined(&__NR_mknod);
    eval 'sub SYS_mknod () { &__NR_mknod;}' unless defined(&SYS_mknod);
    undef(&__NR_chmod) if defined(&__NR_chmod);
    eval 'sub __NR_chmod () {(0+ 15);}' unless defined(&__NR_chmod);
    eval 'sub SYS_chmod () { &__NR_chmod;}' unless defined(&SYS_chmod);
    undef(&__NR_lchown) if defined(&__NR_lchown);
    eval 'sub __NR_lchown () {(0+ 16);}' unless defined(&__NR_lchown);
    eval 'sub SYS_lchown () { &__NR_lchown;}' unless defined(&SYS_lchown);
    undef(&__NR_lseek) if defined(&__NR_lseek);
    eval 'sub __NR_lseek () {(0+ 19);}' unless defined(&__NR_lseek);
    eval 'sub SYS_lseek () { &__NR_lseek;}' unless defined(&SYS_lseek);
    undef(&__NR_getpid) if defined(&__NR_getpid);
    eval 'sub __NR_getpid () {(0+ 20);}' unless defined(&__NR_getpid);
    eval 'sub SYS_getpid () { &__NR_getpid;}' unless defined(&SYS_getpid);
    undef(&__NR_mount) if defined(&__NR_mount);
    eval 'sub __NR_mount () {(0+ 21);}' unless defined(&__NR_mount);
    eval 'sub SYS_mount () { &__NR_mount;}' unless defined(&SYS_mount);
    undef(&__NR_umount) if defined(&__NR_umount);
    eval 'sub SYS_umount () { &__NR_umount;}' unless defined(&SYS_umount);
    undef(&__NR_setuid) if defined(&__NR_setuid);
    eval 'sub __NR_setuid () {(0+ 23);}' unless defined(&__NR_setuid);
    eval 'sub SYS_setuid () { &__NR_setuid;}' unless defined(&SYS_setuid);
    undef(&__NR_getuid) if defined(&__NR_getuid);
    eval 'sub __NR_getuid () {(0+ 24);}' unless defined(&__NR_getuid);
    eval 'sub SYS_getuid () { &__NR_getuid;}' unless defined(&SYS_getuid);
    undef(&__NR_stime) if defined(&__NR_stime);
    eval 'sub SYS_stime () { &__NR_stime;}' unless defined(&SYS_stime);
    undef(&__NR_ptrace) if defined(&__NR_ptrace);
    eval 'sub __NR_ptrace () {(0+ 26);}' unless defined(&__NR_ptrace);
    eval 'sub SYS_ptrace () { &__NR_ptrace;}' unless defined(&SYS_ptrace);
    undef(&__NR_alarm) if defined(&__NR_alarm);
    eval 'sub SYS_alarm () { &__NR_alarm;}' unless defined(&SYS_alarm);
    undef(&__NR_pause) if defined(&__NR_pause);
    eval 'sub __NR_pause () {(0+ 29);}' unless defined(&__NR_pause);
    eval 'sub SYS_pause () { &__NR_pause;}' unless defined(&SYS_pause);
    undef(&__NR_utime) if defined(&__NR_utime);
    eval 'sub SYS_utime () { &__NR_utime;}' unless defined(&SYS_utime);
    undef(&__NR_access) if defined(&__NR_access);
    eval 'sub __NR_access () {(0+ 33);}' unless defined(&__NR_access);
    eval 'sub SYS_access () { &__NR_access;}' unless defined(&SYS_access);
    undef(&__NR_nice) if defined(&__NR_nice);
    eval 'sub __NR_nice () {(0+ 34);}' unless defined(&__NR_nice);
    eval 'sub SYS_nice () { &__NR_nice;}' unless defined(&SYS_nice);
    undef(&__NR_sync) if defined(&__NR_sync);
    eval 'sub __NR_sync () {(0+ 36);}' unless defined(&__NR_sync);
    eval 'sub SYS_sync () { &__NR_sync;}' unless defined(&SYS_sync);
    undef(&__NR_kill) if defined(&__NR_kill);
    eval 'sub __NR_kill () {(0+ 37);}' unless defined(&__NR_kill);
    eval 'sub SYS_kill () { &__NR_kill;}' unless defined(&SYS_kill);
    undef(&__NR_rename) if defined(&__NR_rename);
    eval 'sub __NR_rename () {(0+ 38);}' unless defined(&__NR_rename);
    eval 'sub SYS_rename () { &__NR_rename;}' unless defined(&SYS_rename);
    undef(&__NR_mkdir) if defined(&__NR_mkdir);
    eval 'sub __NR_mkdir () {(0+ 39);}' unless defined(&__NR_mkdir);
    eval 'sub SYS_mkdir () { &__NR_mkdir;}' unless defined(&SYS_mkdir);
    undef(&__NR_rmdir) if defined(&__NR_rmdir);
    eval 'sub __NR_rmdir () {(0+ 40);}' unless defined(&__NR_rmdir);
    eval 'sub SYS_rmdir () { &__NR_rmdir;}' unless defined(&SYS_rmdir);
    undef(&__NR_dup) if defined(&__NR_dup);
    eval 'sub __NR_dup () {(0+ 41);}' unless defined(&__NR_dup);
    eval 'sub SYS_dup () { &__NR_dup;}' unless defined(&SYS_dup);
    undef(&__NR_pipe) if defined(&__NR_pipe);
    eval 'sub __NR_pipe () {(0+ 42);}' unless defined(&__NR_pipe);
    eval 'sub SYS_pipe () { &__NR_pipe;}' unless defined(&SYS_pipe);
    undef(&__NR_times) if defined(&__NR_times);
    eval 'sub __NR_times () {(0+ 43);}' unless defined(&__NR_times);
    eval 'sub SYS_times () { &__NR_times;}' unless defined(&SYS_times);
    undef(&__NR_brk) if defined(&__NR_brk);
    eval 'sub __NR_brk () {(0+ 45);}' unless defined(&__NR_brk);
    eval 'sub SYS_brk () { &__NR_brk;}' unless defined(&SYS_brk);
    undef(&__NR_setgid) if defined(&__NR_setgid);
    eval 'sub __NR_setgid () {(0+ 46);}' unless defined(&__NR_setgid);
    eval 'sub SYS_setgid () { &__NR_setgid;}' unless defined(&SYS_setgid);
    undef(&__NR_getgid) if defined(&__NR_getgid);
    eval 'sub __NR_getgid () {(0+ 47);}' unless defined(&__NR_getgid);
    eval 'sub SYS_getgid () { &__NR_getgid;}' unless defined(&SYS_getgid);
    undef(&__NR_geteuid) if defined(&__NR_geteuid);
    eval 'sub __NR_geteuid () {(0+ 49);}' unless defined(&__NR_geteuid);
    eval 'sub SYS_geteuid () { &__NR_geteuid;}' unless defined(&SYS_geteuid);
    undef(&__NR_getegid) if defined(&__NR_getegid);
    eval 'sub __NR_getegid () {(0+ 50);}' unless defined(&__NR_getegid);
    eval 'sub SYS_getegid () { &__NR_getegid;}' unless defined(&SYS_getegid);
    undef(&__NR_acct) if defined(&__NR_acct);
    eval 'sub __NR_acct () {(0+ 51);}' unless defined(&__NR_acct);
    eval 'sub SYS_acct () { &__NR_acct;}' unless defined(&SYS_acct);
    undef(&__NR_umount2) if defined(&__NR_umount2);
    eval 'sub __NR_umount2 () {(0+ 52);}' unless defined(&__NR_umount2);
    eval 'sub SYS_umount2 () { &__NR_umount2;}' unless defined(&SYS_umount2);
    undef(&__NR_ioctl) if defined(&__NR_ioctl);
    eval 'sub __NR_ioctl () {(0+ 54);}' unless defined(&__NR_ioctl);
    eval 'sub SYS_ioctl () { &__NR_ioctl;}' unless defined(&SYS_ioctl);
    undef(&__NR_fcntl) if defined(&__NR_fcntl);
    eval 'sub __NR_fcntl () {(0+ 55);}' unless defined(&__NR_fcntl);
    eval 'sub SYS_fcntl () { &__NR_fcntl;}' unless defined(&SYS_fcntl);
    undef(&__NR_setpgid) if defined(&__NR_setpgid);
    eval 'sub __NR_setpgid () {(0+ 57);}' unless defined(&__NR_setpgid);
    eval 'sub SYS_setpgid () { &__NR_setpgid;}' unless defined(&SYS_setpgid);
    undef(&__NR_umask) if defined(&__NR_umask);
    eval 'sub __NR_umask () {(0+ 60);}' unless defined(&__NR_umask);
    eval 'sub SYS_umask () { &__NR_umask;}' unless defined(&SYS_umask);
    undef(&__NR_chroot) if defined(&__NR_chroot);
    eval 'sub __NR_chroot () {(0+ 61);}' unless defined(&__NR_chroot);
    eval 'sub SYS_chroot () { &__NR_chroot;}' unless defined(&SYS_chroot);
    undef(&__NR_ustat) if defined(&__NR_ustat);
    eval 'sub __NR_ustat () {(0+ 62);}' unless defined(&__NR_ustat);
    eval 'sub SYS_ustat () { &__NR_ustat;}' unless defined(&SYS_ustat);
    undef(&__NR_dup2) if defined(&__NR_dup2);
    eval 'sub __NR_dup2 () {(0+ 63);}' unless defined(&__NR_dup2);
    eval 'sub SYS_dup2 () { &__NR_dup2;}' unless defined(&SYS_dup2);
    undef(&__NR_getppid) if defined(&__NR_getppid);
    eval 'sub __NR_getppid () {(0+ 64);}' unless defined(&__NR_getppid);
    eval 'sub SYS_getppid () { &__NR_getppid;}' unless defined(&SYS_getppid);
    undef(&__NR_getpgrp) if defined(&__NR_getpgrp);
    eval 'sub __NR_getpgrp () {(0+ 65);}' unless defined(&__NR_getpgrp);
    eval 'sub SYS_getpgrp () { &__NR_getpgrp;}' unless defined(&SYS_getpgrp);
    undef(&__NR_setsid) if defined(&__NR_setsid);
    eval 'sub __NR_setsid () {(0+ 66);}' unless defined(&__NR_setsid);
    eval 'sub SYS_setsid () { &__NR_setsid;}' unless defined(&SYS_setsid);
    undef(&__NR_sigaction) if defined(&__NR_sigaction);
    eval 'sub __NR_sigaction () {(0+ 67);}' unless defined(&__NR_sigaction);
    eval 'sub SYS_sigaction () { &__NR_sigaction;}' unless defined(&SYS_sigaction);
    undef(&__NR_setreuid) if defined(&__NR_setreuid);
    eval 'sub __NR_setreuid () {(0+ 70);}' unless defined(&__NR_setreuid);
    eval 'sub SYS_setreuid () { &__NR_setreuid;}' unless defined(&SYS_setreuid);
    undef(&__NR_setregid) if defined(&__NR_setregid);
    eval 'sub __NR_setregid () {(0+ 71);}' unless defined(&__NR_setregid);
    eval 'sub SYS_setregid () { &__NR_setregid;}' unless defined(&SYS_setregid);
    undef(&__NR_sigsuspend) if defined(&__NR_sigsuspend);
    eval 'sub __NR_sigsuspend () {(0+ 72);}' unless defined(&__NR_sigsuspend);
    eval 'sub SYS_sigsuspend () { &__NR_sigsuspend;}' unless defined(&SYS_sigsuspend);
    undef(&__NR_sigpending) if defined(&__NR_sigpending);
    eval 'sub __NR_sigpending () {(0+ 73);}' unless defined(&__NR_sigpending);
    eval 'sub SYS_sigpending () { &__NR_sigpending;}' unless defined(&SYS_sigpending);
    undef(&__NR_sethostname) if defined(&__NR_sethostname);
    eval 'sub __NR_sethostname () {(0+ 74);}' unless defined(&__NR_sethostname);
    eval 'sub SYS_sethostname () { &__NR_sethostname;}' unless defined(&SYS_sethostname);
    undef(&__NR_setrlimit) if defined(&__NR_setrlimit);
    eval 'sub __NR_setrlimit () {(0+ 75);}' unless defined(&__NR_setrlimit);
    eval 'sub SYS_setrlimit () { &__NR_setrlimit;}' unless defined(&SYS_setrlimit);
    undef(&__NR_getrlimit) if defined(&__NR_getrlimit);
    eval 'sub SYS_getrlimit () { &__NR_getrlimit;}' unless defined(&SYS_getrlimit);
    undef(&__NR_getrusage) if defined(&__NR_getrusage);
    eval 'sub __NR_getrusage () {(0+ 77);}' unless defined(&__NR_getrusage);
    eval 'sub SYS_getrusage () { &__NR_getrusage;}' unless defined(&SYS_getrusage);
    undef(&__NR_gettimeofday) if defined(&__NR_gettimeofday);
    eval 'sub __NR_gettimeofday () {(0+ 78);}' unless defined(&__NR_gettimeofday);
    eval 'sub SYS_gettimeofday () { &__NR_gettimeofday;}' unless defined(&SYS_gettimeofday);
    undef(&__NR_settimeofday) if defined(&__NR_settimeofday);
    eval 'sub __NR_settimeofday () {(0+ 79);}' unless defined(&__NR_settimeofday);
    eval 'sub SYS_settimeofday () { &__NR_settimeofday;}' unless defined(&SYS_settimeofday);
    undef(&__NR_getgroups) if defined(&__NR_getgroups);
    eval 'sub __NR_getgroups () {(0+ 80);}' unless defined(&__NR_getgroups);
    eval 'sub SYS_getgroups () { &__NR_getgroups;}' unless defined(&SYS_getgroups);
    undef(&__NR_setgroups) if defined(&__NR_setgroups);
    eval 'sub __NR_setgroups () {(0+ 81);}' unless defined(&__NR_setgroups);
    eval 'sub SYS_setgroups () { &__NR_setgroups;}' unless defined(&SYS_setgroups);
    undef(&__NR_select) if defined(&__NR_select);
    eval 'sub SYS_select () { &__NR_select;}' unless defined(&SYS_select);
    undef(&__NR_symlink) if defined(&__NR_symlink);
    eval 'sub __NR_symlink () {(0+ 83);}' unless defined(&__NR_symlink);
    eval 'sub SYS_symlink () { &__NR_symlink;}' unless defined(&SYS_symlink);
    undef(&__NR_readlink) if defined(&__NR_readlink);
    eval 'sub __NR_readlink () {(0+ 85);}' unless defined(&__NR_readlink);
    eval 'sub SYS_readlink () { &__NR_readlink;}' unless defined(&SYS_readlink);
    undef(&__NR_uselib) if defined(&__NR_uselib);
    eval 'sub __NR_uselib () {(0+ 86);}' unless defined(&__NR_uselib);
    eval 'sub SYS_uselib () { &__NR_uselib;}' unless defined(&SYS_uselib);
    undef(&__NR_swapon) if defined(&__NR_swapon);
    eval 'sub __NR_swapon () {(0+ 87);}' unless defined(&__NR_swapon);
    eval 'sub SYS_swapon () { &__NR_swapon;}' unless defined(&SYS_swapon);
    undef(&__NR_reboot) if defined(&__NR_reboot);
    eval 'sub __NR_reboot () {(0+ 88);}' unless defined(&__NR_reboot);
    eval 'sub SYS_reboot () { &__NR_reboot;}' unless defined(&SYS_reboot);
    undef(&__NR_readdir) if defined(&__NR_readdir);
    eval 'sub SYS_readdir () { &__NR_readdir;}' unless defined(&SYS_readdir);
    undef(&__NR_mmap) if defined(&__NR_mmap);
    eval 'sub SYS_mmap () { &__NR_mmap;}' unless defined(&SYS_mmap);
    undef(&__NR_munmap) if defined(&__NR_munmap);
    eval 'sub __NR_munmap () {(0+ 91);}' unless defined(&__NR_munmap);
    eval 'sub SYS_munmap () { &__NR_munmap;}' unless defined(&SYS_munmap);
    undef(&__NR_truncate) if defined(&__NR_truncate);
    eval 'sub __NR_truncate () {(0+ 92);}' unless defined(&__NR_truncate);
    eval 'sub SYS_truncate () { &__NR_truncate;}' unless defined(&SYS_truncate);
    undef(&__NR_ftruncate) if defined(&__NR_ftruncate);
    eval 'sub __NR_ftruncate () {(0+ 93);}' unless defined(&__NR_ftruncate);
    eval 'sub SYS_ftruncate () { &__NR_ftruncate;}' unless defined(&SYS_ftruncate);
    undef(&__NR_fchmod) if defined(&__NR_fchmod);
    eval 'sub __NR_fchmod () {(0+ 94);}' unless defined(&__NR_fchmod);
    eval 'sub SYS_fchmod () { &__NR_fchmod;}' unless defined(&SYS_fchmod);
    undef(&__NR_fchown) if defined(&__NR_fchown);
    eval 'sub __NR_fchown () {(0+ 95);}' unless defined(&__NR_fchown);
    eval 'sub SYS_fchown () { &__NR_fchown;}' unless defined(&SYS_fchown);
    undef(&__NR_getpriority) if defined(&__NR_getpriority);
    eval 'sub __NR_getpriority () {(0+ 96);}' unless defined(&__NR_getpriority);
    eval 'sub SYS_getpriority () { &__NR_getpriority;}' unless defined(&SYS_getpriority);
    undef(&__NR_setpriority) if defined(&__NR_setpriority);
    eval 'sub __NR_setpriority () {(0+ 97);}' unless defined(&__NR_setpriority);
    eval 'sub SYS_setpriority () { &__NR_setpriority;}' unless defined(&SYS_setpriority);
    undef(&__NR_statfs) if defined(&__NR_statfs);
    eval 'sub __NR_statfs () {(0+ 99);}' unless defined(&__NR_statfs);
    eval 'sub SYS_statfs () { &__NR_statfs;}' unless defined(&SYS_statfs);
    undef(&__NR_fstatfs) if defined(&__NR_fstatfs);
    eval 'sub __NR_fstatfs () {(0+100);}' unless defined(&__NR_fstatfs);
    eval 'sub SYS_fstatfs () { &__NR_fstatfs;}' unless defined(&SYS_fstatfs);
    undef(&__NR_socketcall) if defined(&__NR_socketcall);
    eval 'sub SYS_socketcall () { &__NR_socketcall;}' unless defined(&SYS_socketcall);
    undef(&__NR_syslog) if defined(&__NR_syslog);
    eval 'sub __NR_syslog () {(0+103);}' unless defined(&__NR_syslog);
    eval 'sub SYS_syslog () { &__NR_syslog;}' unless defined(&SYS_syslog);
    undef(&__NR_setitimer) if defined(&__NR_setitimer);
    eval 'sub __NR_setitimer () {(0+104);}' unless defined(&__NR_setitimer);
    eval 'sub SYS_setitimer () { &__NR_setitimer;}' unless defined(&SYS_setitimer);
    undef(&__NR_getitimer) if defined(&__NR_getitimer);
    eval 'sub __NR_getitimer () {(0+105);}' unless defined(&__NR_getitimer);
    eval 'sub SYS_getitimer () { &__NR_getitimer;}' unless defined(&SYS_getitimer);
    undef(&__NR_stat) if defined(&__NR_stat);
    eval 'sub __NR_stat () {(0+106);}' unless defined(&__NR_stat);
    eval 'sub SYS_stat () { &__NR_stat;}' unless defined(&SYS_stat);
    undef(&__NR_lstat) if defined(&__NR_lstat);
    eval 'sub __NR_lstat () {(0+107);}' unless defined(&__NR_lstat);
    eval 'sub SYS_lstat () { &__NR_lstat;}' unless defined(&SYS_lstat);
    undef(&__NR_fstat) if defined(&__NR_fstat);
    eval 'sub __NR_fstat () {(0+108);}' unless defined(&__NR_fstat);
    eval 'sub SYS_fstat () { &__NR_fstat;}' unless defined(&SYS_fstat);
    undef(&__NR_vhangup) if defined(&__NR_vhangup);
    eval 'sub __NR_vhangup () {(0+111);}' unless defined(&__NR_vhangup);
    eval 'sub SYS_vhangup () { &__NR_vhangup;}' unless defined(&SYS_vhangup);
    undef(&__NR_syscall) if defined(&__NR_syscall);
    eval 'sub SYS_syscall () { &__NR_syscall;}' unless defined(&SYS_syscall);
    undef(&__NR_wait4) if defined(&__NR_wait4);
    eval 'sub __NR_wait4 () {(0+114);}' unless defined(&__NR_wait4);
    eval 'sub SYS_wait4 () { &__NR_wait4;}' unless defined(&SYS_wait4);
    undef(&__NR_swapoff) if defined(&__NR_swapoff);
    eval 'sub __NR_swapoff () {(0+115);}' unless defined(&__NR_swapoff);
    eval 'sub SYS_swapoff () { &__NR_swapoff;}' unless defined(&SYS_swapoff);
    undef(&__NR_sysinfo) if defined(&__NR_sysinfo);
    eval 'sub __NR_sysinfo () {(0+116);}' unless defined(&__NR_sysinfo);
    eval 'sub SYS_sysinfo () { &__NR_sysinfo;}' unless defined(&SYS_sysinfo);
    undef(&__NR_ipc) if defined(&__NR_ipc);
    eval 'sub SYS_ipc () { &__NR_ipc;}' unless defined(&SYS_ipc);
    undef(&__NR_fsync) if defined(&__NR_fsync);
    eval 'sub __NR_fsync () {(0+118);}' unless defined(&__NR_fsync);
    eval 'sub SYS_fsync () { &__NR_fsync;}' unless defined(&SYS_fsync);
    undef(&__NR_sigreturn) if defined(&__NR_sigreturn);
    eval 'sub __NR_sigreturn () {(0+119);}' unless defined(&__NR_sigreturn);
    eval 'sub SYS_sigreturn () { &__NR_sigreturn;}' unless defined(&SYS_sigreturn);
    undef(&__NR_clone) if defined(&__NR_clone);
    eval 'sub __NR_clone () {(0+120);}' unless defined(&__NR_clone);
    eval 'sub SYS_clone () { &__NR_clone;}' unless defined(&SYS_clone);
    undef(&__NR_setdomainname) if defined(&__NR_setdomainname);
    eval 'sub __NR_setdomainname () {(0+121);}' unless defined(&__NR_setdomainname);
    eval 'sub SYS_setdomainname () { &__NR_setdomainname;}' unless defined(&SYS_setdomainname);
    undef(&__NR_uname) if defined(&__NR_uname);
    eval 'sub __NR_uname () {(0+122);}' unless defined(&__NR_uname);
    eval 'sub SYS_uname () { &__NR_uname;}' unless defined(&SYS_uname);
    undef(&__NR_adjtimex) if defined(&__NR_adjtimex);
    eval 'sub __NR_adjtimex () {(0+124);}' unless defined(&__NR_adjtimex);
    eval 'sub SYS_adjtimex () { &__NR_adjtimex;}' unless defined(&SYS_adjtimex);
    undef(&__NR_mprotect) if defined(&__NR_mprotect);
    eval 'sub __NR_mprotect () {(0+125);}' unless defined(&__NR_mprotect);
    eval 'sub SYS_mprotect () { &__NR_mprotect;}' unless defined(&SYS_mprotect);
    undef(&__NR_sigprocmask) if defined(&__NR_sigprocmask);
    eval 'sub __NR_sigprocmask () {(0+126);}' unless defined(&__NR_sigprocmask);
    eval 'sub SYS_sigprocmask () { &__NR_sigprocmask;}' unless defined(&SYS_sigprocmask);
    undef(&__NR_init_module) if defined(&__NR_init_module);
    eval 'sub __NR_init_module () {(0+128);}' unless defined(&__NR_init_module);
    eval 'sub SYS_init_module () { &__NR_init_module;}' unless defined(&SYS_init_module);
    undef(&__NR_delete_module) if defined(&__NR_delete_module);
    eval 'sub __NR_delete_module () {(0+129);}' unless defined(&__NR_delete_module);
    eval 'sub SYS_delete_module () { &__NR_delete_module;}' unless defined(&SYS_delete_module);
    undef(&__NR_quotactl) if defined(&__NR_quotactl);
    eval 'sub __NR_quotactl () {(0+131);}' unless defined(&__NR_quotactl);
    eval 'sub SYS_quotactl () { &__NR_quotactl;}' unless defined(&SYS_quotactl);
    undef(&__NR_getpgid) if defined(&__NR_getpgid);
    eval 'sub __NR_getpgid () {(0+132);}' unless defined(&__NR_getpgid);
    eval 'sub SYS_getpgid () { &__NR_getpgid;}' unless defined(&SYS_getpgid);
    undef(&__NR_fchdir) if defined(&__NR_fchdir);
    eval 'sub __NR_fchdir () {(0+133);}' unless defined(&__NR_fchdir);
    eval 'sub SYS_fchdir () { &__NR_fchdir;}' unless defined(&SYS_fchdir);
    undef(&__NR_bdflush) if defined(&__NR_bdflush);
    eval 'sub __NR_bdflush () {(0+134);}' unless defined(&__NR_bdflush);
    eval 'sub SYS_bdflush () { &__NR_bdflush;}' unless defined(&SYS_bdflush);
    undef(&__NR_sysfs) if defined(&__NR_sysfs);
    eval 'sub __NR_sysfs () {(0+135);}' unless defined(&__NR_sysfs);
    eval 'sub SYS_sysfs () { &__NR_sysfs;}' unless defined(&SYS_sysfs);
    undef(&__NR_personality) if defined(&__NR_personality);
    eval 'sub __NR_personality () {(0+136);}' unless defined(&__NR_personality);
    eval 'sub SYS_personality () { &__NR_personality;}' unless defined(&SYS_personality);
    undef(&__NR_setfsuid) if defined(&__NR_setfsuid);
    eval 'sub __NR_setfsuid () {(0+138);}' unless defined(&__NR_setfsuid);
    eval 'sub SYS_setfsuid () { &__NR_setfsuid;}' unless defined(&SYS_setfsuid);
    undef(&__NR_setfsgid) if defined(&__NR_setfsgid);
    eval 'sub __NR_setfsgid () {(0+139);}' unless defined(&__NR_setfsgid);
    eval 'sub SYS_setfsgid () { &__NR_setfsgid;}' unless defined(&SYS_setfsgid);
    undef(&__NR__llseek) if defined(&__NR__llseek);
    eval 'sub __NR__llseek () {(0+140);}' unless defined(&__NR__llseek);
    eval 'sub SYS__llseek () { &__NR__llseek;}' unless defined(&SYS__llseek);
    undef(&__NR_getdents) if defined(&__NR_getdents);
    eval 'sub __NR_getdents () {(0+141);}' unless defined(&__NR_getdents);
    eval 'sub SYS_getdents () { &__NR_getdents;}' unless defined(&SYS_getdents);
    undef(&__NR__newselect) if defined(&__NR__newselect);
    eval 'sub __NR__newselect () {(0+142);}' unless defined(&__NR__newselect);
    eval 'sub SYS__newselect () { &__NR__newselect;}' unless defined(&SYS__newselect);
    undef(&__NR_flock) if defined(&__NR_flock);
    eval 'sub __NR_flock () {(0+143);}' unless defined(&__NR_flock);
    eval 'sub SYS_flock () { &__NR_flock;}' unless defined(&SYS_flock);
    undef(&__NR_msync) if defined(&__NR_msync);
    eval 'sub __NR_msync () {(0+144);}' unless defined(&__NR_msync);
    eval 'sub SYS_msync () { &__NR_msync;}' unless defined(&SYS_msync);
    undef(&__NR_readv) if defined(&__NR_readv);
    eval 'sub __NR_readv () {(0+145);}' unless defined(&__NR_readv);
    eval 'sub SYS_readv () { &__NR_readv;}' unless defined(&SYS_readv);
    undef(&__NR_writev) if defined(&__NR_writev);
    eval 'sub __NR_writev () {(0+146);}' unless defined(&__NR_writev);
    eval 'sub SYS_writev () { &__NR_writev;}' unless defined(&SYS_writev);
    undef(&__NR_getsid) if defined(&__NR_getsid);
    eval 'sub __NR_getsid () {(0+147);}' unless defined(&__NR_getsid);
    eval 'sub SYS_getsid () { &__NR_getsid;}' unless defined(&SYS_getsid);
    undef(&__NR_fdatasync) if defined(&__NR_fdatasync);
    eval 'sub __NR_fdatasync () {(0+148);}' unless defined(&__NR_fdatasync);
    eval 'sub SYS_fdatasync () { &__NR_fdatasync;}' unless defined(&SYS_fdatasync);
    undef(&__NR__sysctl) if defined(&__NR__sysctl);
    eval 'sub __NR__sysctl () {(0+149);}' unless defined(&__NR__sysctl);
    eval 'sub SYS__sysctl () { &__NR__sysctl;}' unless defined(&SYS__sysctl);
    undef(&__NR_mlock) if defined(&__NR_mlock);
    eval 'sub __NR_mlock () {(0+150);}' unless defined(&__NR_mlock);
    eval 'sub SYS_mlock () { &__NR_mlock;}' unless defined(&SYS_mlock);
    undef(&__NR_munlock) if defined(&__NR_munlock);
    eval 'sub __NR_munlock () {(0+151);}' unless defined(&__NR_munlock);
    eval 'sub SYS_munlock () { &__NR_munlock;}' unless defined(&SYS_munlock);
    undef(&__NR_mlockall) if defined(&__NR_mlockall);
    eval 'sub __NR_mlockall () {(0+152);}' unless defined(&__NR_mlockall);
    eval 'sub SYS_mlockall () { &__NR_mlockall;}' unless defined(&SYS_mlockall);
    undef(&__NR_munlockall) if defined(&__NR_munlockall);
    eval 'sub __NR_munlockall () {(0+153);}' unless defined(&__NR_munlockall);
    eval 'sub SYS_munlockall () { &__NR_munlockall;}' unless defined(&SYS_munlockall);
    undef(&__NR_sched_setparam) if defined(&__NR_sched_setparam);
    eval 'sub __NR_sched_setparam () {(0+154);}' unless defined(&__NR_sched_setparam);
    eval 'sub SYS_sched_setparam () { &__NR_sched_setparam;}' unless defined(&SYS_sched_setparam);
    undef(&__NR_sched_getparam) if defined(&__NR_sched_getparam);
    eval 'sub __NR_sched_getparam () {(0+155);}' unless defined(&__NR_sched_getparam);
    eval 'sub SYS_sched_getparam () { &__NR_sched_getparam;}' unless defined(&SYS_sched_getparam);
    undef(&__NR_sched_setscheduler) if defined(&__NR_sched_setscheduler);
    eval 'sub __NR_sched_setscheduler () {(0+156);}' unless defined(&__NR_sched_setscheduler);
    eval 'sub SYS_sched_setscheduler () { &__NR_sched_setscheduler;}' unless defined(&SYS_sched_setscheduler);
    undef(&__NR_sched_getscheduler) if defined(&__NR_sched_getscheduler);
    eval 'sub __NR_sched_getscheduler () {(0+157);}' unless defined(&__NR_sched_getscheduler);
    eval 'sub SYS_sched_getscheduler () { &__NR_sched_getscheduler;}' unless defined(&SYS_sched_getscheduler);
    undef(&__NR_sched_yield) if defined(&__NR_sched_yield);
    eval 'sub __NR_sched_yield () {(0+158);}' unless defined(&__NR_sched_yield);
    eval 'sub SYS_sched_yield () { &__NR_sched_yield;}' unless defined(&SYS_sched_yield);
    undef(&__NR_sched_get_priority_max) if defined(&__NR_sched_get_priority_max);
    eval 'sub __NR_sched_get_priority_max () {(0+159);}' unless defined(&__NR_sched_get_priority_max);
    eval 'sub SYS_sched_get_priority_max () { &__NR_sched_get_priority_max;}' unless defined(&SYS_sched_get_priority_max);
    undef(&__NR_sched_get_priority_min) if defined(&__NR_sched_get_priority_min);
    eval 'sub __NR_sched_get_priority_min () {(0+160);}' unless defined(&__NR_sched_get_priority_min);
    eval 'sub SYS_sched_get_priority_min () { &__NR_sched_get_priority_min;}' unless defined(&SYS_sched_get_priority_min);
    undef(&__NR_sched_rr_get_interval) if defined(&__NR_sched_rr_get_interval);
    eval 'sub __NR_sched_rr_get_interval () {(0+161);}' unless defined(&__NR_sched_rr_get_interval);
    eval 'sub SYS_sched_rr_get_interval () { &__NR_sched_rr_get_interval;}' unless defined(&SYS_sched_rr_get_interval);
    undef(&__NR_nanosleep) if defined(&__NR_nanosleep);
    eval 'sub __NR_nanosleep () {(0+162);}' unless defined(&__NR_nanosleep);
    eval 'sub SYS_nanosleep () { &__NR_nanosleep;}' unless defined(&SYS_nanosleep);
    undef(&__NR_mremap) if defined(&__NR_mremap);
    eval 'sub __NR_mremap () {(0+163);}' unless defined(&__NR_mremap);
    eval 'sub SYS_mremap () { &__NR_mremap;}' unless defined(&SYS_mremap);
    undef(&__NR_setresuid) if defined(&__NR_setresuid);
    eval 'sub __NR_setresuid () {(0+164);}' unless defined(&__NR_setresuid);
    eval 'sub SYS_setresuid () { &__NR_setresuid;}' unless defined(&SYS_setresuid);
    undef(&__NR_getresuid) if defined(&__NR_getresuid);
    eval 'sub __NR_getresuid () {(0+165);}' unless defined(&__NR_getresuid);
    eval 'sub SYS_getresuid () { &__NR_getresuid;}' unless defined(&SYS_getresuid);
    undef(&__NR_poll) if defined(&__NR_poll);
    eval 'sub __NR_poll () {(0+168);}' unless defined(&__NR_poll);
    eval 'sub SYS_poll () { &__NR_poll;}' unless defined(&SYS_poll);
    undef(&__NR_nfsservctl) if defined(&__NR_nfsservctl);
    eval 'sub __NR_nfsservctl () {(0+169);}' unless defined(&__NR_nfsservctl);
    eval 'sub SYS_nfsservctl () { &__NR_nfsservctl;}' unless defined(&SYS_nfsservctl);
    undef(&__NR_setresgid) if defined(&__NR_setresgid);
    eval 'sub __NR_setresgid () {(0+170);}' unless defined(&__NR_setresgid);
    eval 'sub SYS_setresgid () { &__NR_setresgid;}' unless defined(&SYS_setresgid);
    undef(&__NR_getresgid) if defined(&__NR_getresgid);
    eval 'sub __NR_getresgid () {(0+171);}' unless defined(&__NR_getresgid);
    eval 'sub SYS_getresgid () { &__NR_getresgid;}' unless defined(&SYS_getresgid);
    undef(&__NR_prctl) if defined(&__NR_prctl);
    eval 'sub __NR_prctl () {(0+172);}' unless defined(&__NR_prctl);
    eval 'sub SYS_prctl () { &__NR_prctl;}' unless defined(&SYS_prctl);
    undef(&__NR_rt_sigreturn) if defined(&__NR_rt_sigreturn);
    eval 'sub __NR_rt_sigreturn () {(0+173);}' unless defined(&__NR_rt_sigreturn);
    eval 'sub SYS_rt_sigreturn () { &__NR_rt_sigreturn;}' unless defined(&SYS_rt_sigreturn);
    undef(&__NR_rt_sigaction) if defined(&__NR_rt_sigaction);
    eval 'sub __NR_rt_sigaction () {(0+174);}' unless defined(&__NR_rt_sigaction);
    eval 'sub SYS_rt_sigaction () { &__NR_rt_sigaction;}' unless defined(&SYS_rt_sigaction);
    undef(&__NR_rt_sigprocmask) if defined(&__NR_rt_sigprocmask);
    eval 'sub __NR_rt_sigprocmask () {(0+175);}' unless defined(&__NR_rt_sigprocmask);
    eval 'sub SYS_rt_sigprocmask () { &__NR_rt_sigprocmask;}' unless defined(&SYS_rt_sigprocmask);
    undef(&__NR_rt_sigpending) if defined(&__NR_rt_sigpending);
    eval 'sub __NR_rt_sigpending () {(0+176);}' unless defined(&__NR_rt_sigpending);
    eval 'sub SYS_rt_sigpending () { &__NR_rt_sigpending;}' unless defined(&SYS_rt_sigpending);
    undef(&__NR_rt_sigtimedwait) if defined(&__NR_rt_sigtimedwait);
    eval 'sub __NR_rt_sigtimedwait () {(0+177);}' unless defined(&__NR_rt_sigtimedwait);
    eval 'sub SYS_rt_sigtimedwait () { &__NR_rt_sigtimedwait;}' unless defined(&SYS_rt_sigtimedwait);
    undef(&__NR_rt_sigqueueinfo) if defined(&__NR_rt_sigqueueinfo);
    eval 'sub __NR_rt_sigqueueinfo () {(0+178);}' unless defined(&__NR_rt_sigqueueinfo);
    eval 'sub SYS_rt_sigqueueinfo () { &__NR_rt_sigqueueinfo;}' unless defined(&SYS_rt_sigqueueinfo);
    undef(&__NR_rt_sigsuspend) if defined(&__NR_rt_sigsuspend);
    eval 'sub __NR_rt_sigsuspend () {(0+179);}' unless defined(&__NR_rt_sigsuspend);
    eval 'sub SYS_rt_sigsuspend () { &__NR_rt_sigsuspend;}' unless defined(&SYS_rt_sigsuspend);
    undef(&__NR_pread64) if defined(&__NR_pread64);
    eval 'sub __NR_pread64 () {(0+180);}' unless defined(&__NR_pread64);
    eval 'sub SYS_pread64 () { &__NR_pread64;}' unless defined(&SYS_pread64);
    undef(&__NR_pwrite64) if defined(&__NR_pwrite64);
    eval 'sub __NR_pwrite64 () {(0+181);}' unless defined(&__NR_pwrite64);
    eval 'sub SYS_pwrite64 () { &__NR_pwrite64;}' unless defined(&SYS_pwrite64);
    undef(&__NR_chown) if defined(&__NR_chown);
    eval 'sub __NR_chown () {(0+182);}' unless defined(&__NR_chown);
    eval 'sub SYS_chown () { &__NR_chown;}' unless defined(&SYS_chown);
    undef(&__NR_getcwd) if defined(&__NR_getcwd);
    eval 'sub __NR_getcwd () {(0+183);}' unless defined(&__NR_getcwd);
    eval 'sub SYS_getcwd () { &__NR_getcwd;}' unless defined(&SYS_getcwd);
    undef(&__NR_capget) if defined(&__NR_capget);
    eval 'sub __NR_capget () {(0+184);}' unless defined(&__NR_capget);
    eval 'sub SYS_capget () { &__NR_capget;}' unless defined(&SYS_capget);
    undef(&__NR_capset) if defined(&__NR_capset);
    eval 'sub __NR_capset () {(0+185);}' unless defined(&__NR_capset);
    eval 'sub SYS_capset () { &__NR_capset;}' unless defined(&SYS_capset);
    undef(&__NR_sigaltstack) if defined(&__NR_sigaltstack);
    eval 'sub __NR_sigaltstack () {(0+186);}' unless defined(&__NR_sigaltstack);
    eval 'sub SYS_sigaltstack () { &__NR_sigaltstack;}' unless defined(&SYS_sigaltstack);
    undef(&__NR_sendfile) if defined(&__NR_sendfile);
    eval 'sub __NR_sendfile () {(0+187);}' unless defined(&__NR_sendfile);
    eval 'sub SYS_sendfile () { &__NR_sendfile;}' unless defined(&SYS_sendfile);
    undef(&__NR_vfork) if defined(&__NR_vfork);
    eval 'sub __NR_vfork () {(0+190);}' unless defined(&__NR_vfork);
    eval 'sub SYS_vfork () { &__NR_vfork;}' unless defined(&SYS_vfork);
    undef(&__NR_ugetrlimit) if defined(&__NR_ugetrlimit);
    eval 'sub __NR_ugetrlimit () {(0+191);}' unless defined(&__NR_ugetrlimit);
    eval 'sub SYS_ugetrlimit () { &__NR_ugetrlimit;}' unless defined(&SYS_ugetrlimit);
    undef(&__NR_mmap2) if defined(&__NR_mmap2);
    eval 'sub __NR_mmap2 () {(0+192);}' unless defined(&__NR_mmap2);
    eval 'sub SYS_mmap2 () { &__NR_mmap2;}' unless defined(&SYS_mmap2);
    undef(&__NR_truncate64) if defined(&__NR_truncate64);
    eval 'sub __NR_truncate64 () {(0+193);}' unless defined(&__NR_truncate64);
    eval 'sub SYS_truncate64 () { &__NR_truncate64;}' unless defined(&SYS_truncate64);
    undef(&__NR_ftruncate64) if defined(&__NR_ftruncate64);
    eval 'sub __NR_ftruncate64 () {(0+194);}' unless defined(&__NR_ftruncate64);
    eval 'sub SYS_ftruncate64 () { &__NR_ftruncate64;}' unless defined(&SYS_ftruncate64);
    undef(&__NR_stat64) if defined(&__NR_stat64);
    eval 'sub __NR_stat64 () {(0+195);}' unless defined(&__NR_stat64);
    eval 'sub SYS_stat64 () { &__NR_stat64;}' unless defined(&SYS_stat64);
    undef(&__NR_lstat64) if defined(&__NR_lstat64);
    eval 'sub __NR_lstat64 () {(0+196);}' unless defined(&__NR_lstat64);
    eval 'sub SYS_lstat64 () { &__NR_lstat64;}' unless defined(&SYS_lstat64);
    undef(&__NR_fstat64) if defined(&__NR_fstat64);
    eval 'sub __NR_fstat64 () {(0+197);}' unless defined(&__NR_fstat64);
    eval 'sub SYS_fstat64 () { &__NR_fstat64;}' unless defined(&SYS_fstat64);
    undef(&__NR_lchown32) if defined(&__NR_lchown32);
    eval 'sub __NR_lchown32 () {(0+198);}' unless defined(&__NR_lchown32);
    eval 'sub SYS_lchown32 () { &__NR_lchown32;}' unless defined(&SYS_lchown32);
    undef(&__NR_getuid32) if defined(&__NR_getuid32);
    eval 'sub __NR_getuid32 () {(0+199);}' unless defined(&__NR_getuid32);
    eval 'sub SYS_getuid32 () { &__NR_getuid32;}' unless defined(&SYS_getuid32);
    undef(&__NR_getgid32) if defined(&__NR_getgid32);
    eval 'sub __NR_getgid32 () {(0+200);}' unless defined(&__NR_getgid32);
    eval 'sub SYS_getgid32 () { &__NR_getgid32;}' unless defined(&SYS_getgid32);
    undef(&__NR_geteuid32) if defined(&__NR_geteuid32);
    eval 'sub __NR_geteuid32 () {(0+201);}' unless defined(&__NR_geteuid32);
    eval 'sub SYS_geteuid32 () { &__NR_geteuid32;}' unless defined(&SYS_geteuid32);
    undef(&__NR_getegid32) if defined(&__NR_getegid32);
    eval 'sub __NR_getegid32 () {(0+202);}' unless defined(&__NR_getegid32);
    eval 'sub SYS_getegid32 () { &__NR_getegid32;}' unless defined(&SYS_getegid32);
    undef(&__NR_setreuid32) if defined(&__NR_setreuid32);
    eval 'sub __NR_setreuid32 () {(0+203);}' unless defined(&__NR_setreuid32);
    eval 'sub SYS_setreuid32 () { &__NR_setreuid32;}' unless defined(&SYS_setreuid32);
    undef(&__NR_setregid32) if defined(&__NR_setregid32);
    eval 'sub __NR_setregid32 () {(0+204);}' unless defined(&__NR_setregid32);
    eval 'sub SYS_setregid32 () { &__NR_setregid32;}' unless defined(&SYS_setregid32);
    undef(&__NR_getgroups32) if defined(&__NR_getgroups32);
    eval 'sub __NR_getgroups32 () {(0+205);}' unless defined(&__NR_getgroups32);
    eval 'sub SYS_getgroups32 () { &__NR_getgroups32;}' unless defined(&SYS_getgroups32);
    undef(&__NR_setgroups32) if defined(&__NR_setgroups32);
    eval 'sub __NR_setgroups32 () {(0+206);}' unless defined(&__NR_setgroups32);
    eval 'sub SYS_setgroups32 () { &__NR_setgroups32;}' unless defined(&SYS_setgroups32);
    undef(&__NR_fchown32) if defined(&__NR_fchown32);
    eval 'sub __NR_fchown32 () {(0+207);}' unless defined(&__NR_fchown32);
    eval 'sub SYS_fchown32 () { &__NR_fchown32;}' unless defined(&SYS_fchown32);
    undef(&__NR_setresuid32) if defined(&__NR_setresuid32);
    eval 'sub __NR_setresuid32 () {(0+208);}' unless defined(&__NR_setresuid32);
    eval 'sub SYS_setresuid32 () { &__NR_setresuid32;}' unless defined(&SYS_setresuid32);
    undef(&__NR_getresuid32) if defined(&__NR_getresuid32);
    eval 'sub __NR_getresuid32 () {(0+209);}' unless defined(&__NR_getresuid32);
    eval 'sub SYS_getresuid32 () { &__NR_getresuid32;}' unless defined(&SYS_getresuid32);
    undef(&__NR_setresgid32) if defined(&__NR_setresgid32);
    eval 'sub __NR_setresgid32 () {(0+210);}' unless defined(&__NR_setresgid32);
    eval 'sub SYS_setresgid32 () { &__NR_setresgid32;}' unless defined(&SYS_setresgid32);
    undef(&__NR_getresgid32) if defined(&__NR_getresgid32);
    eval 'sub __NR_getresgid32 () {(0+211);}' unless defined(&__NR_getresgid32);
    eval 'sub SYS_getresgid32 () { &__NR_getresgid32;}' unless defined(&SYS_getresgid32);
    undef(&__NR_chown32) if defined(&__NR_chown32);
    eval 'sub __NR_chown32 () {(0+212);}' unless defined(&__NR_chown32);
    eval 'sub SYS_chown32 () { &__NR_chown32;}' unless defined(&SYS_chown32);
    undef(&__NR_setuid32) if defined(&__NR_setuid32);
    eval 'sub __NR_setuid32 () {(0+213);}' unless defined(&__NR_setuid32);
    eval 'sub SYS_setuid32 () { &__NR_setuid32;}' unless defined(&SYS_setuid32);
    undef(&__NR_setgid32) if defined(&__NR_setgid32);
    eval 'sub __NR_setgid32 () {(0+214);}' unless defined(&__NR_setgid32);
    eval 'sub SYS_setgid32 () { &__NR_setgid32;}' unless defined(&SYS_setgid32);
    undef(&__NR_setfsuid32) if defined(&__NR_setfsuid32);
    eval 'sub __NR_setfsuid32 () {(0+215);}' unless defined(&__NR_setfsuid32);
    eval 'sub SYS_setfsuid32 () { &__NR_setfsuid32;}' unless defined(&SYS_setfsuid32);
    undef(&__NR_setfsgid32) if defined(&__NR_setfsgid32);
    eval 'sub __NR_setfsgid32 () {(0+216);}' unless defined(&__NR_setfsgid32);
    eval 'sub SYS_setfsgid32 () { &__NR_setfsgid32;}' unless defined(&SYS_setfsgid32);
    undef(&__NR_getdents64) if defined(&__NR_getdents64);
    eval 'sub __NR_getdents64 () {(0+217);}' unless defined(&__NR_getdents64);
    eval 'sub SYS_getdents64 () { &__NR_getdents64;}' unless defined(&SYS_getdents64);
    undef(&__NR_pivot_root) if defined(&__NR_pivot_root);
    eval 'sub __NR_pivot_root () {(0+218);}' unless defined(&__NR_pivot_root);
    eval 'sub SYS_pivot_root () { &__NR_pivot_root;}' unless defined(&SYS_pivot_root);
    undef(&__NR_mincore) if defined(&__NR_mincore);
    eval 'sub __NR_mincore () {(0+219);}' unless defined(&__NR_mincore);
    eval 'sub SYS_mincore () { &__NR_mincore;}' unless defined(&SYS_mincore);
    undef(&__NR_madvise) if defined(&__NR_madvise);
    eval 'sub __NR_madvise () {(0+220);}' unless defined(&__NR_madvise);
    eval 'sub SYS_madvise () { &__NR_madvise;}' unless defined(&SYS_madvise);
    undef(&__NR_fcntl64) if defined(&__NR_fcntl64);
    eval 'sub __NR_fcntl64 () {(0+221);}' unless defined(&__NR_fcntl64);
    eval 'sub SYS_fcntl64 () { &__NR_fcntl64;}' unless defined(&SYS_fcntl64);
    undef(&__NR_gettid) if defined(&__NR_gettid);
    eval 'sub __NR_gettid () {(0+224);}' unless defined(&__NR_gettid);
    eval 'sub SYS_gettid () { &__NR_gettid;}' unless defined(&SYS_gettid);
    undef(&__NR_readahead) if defined(&__NR_readahead);
    eval 'sub __NR_readahead () {(0+225);}' unless defined(&__NR_readahead);
    eval 'sub SYS_readahead () { &__NR_readahead;}' unless defined(&SYS_readahead);
    undef(&__NR_setxattr) if defined(&__NR_setxattr);
    eval 'sub __NR_setxattr () {(0+226);}' unless defined(&__NR_setxattr);
    eval 'sub SYS_setxattr () { &__NR_setxattr;}' unless defined(&SYS_setxattr);
    undef(&__NR_lsetxattr) if defined(&__NR_lsetxattr);
    eval 'sub __NR_lsetxattr () {(0+227);}' unless defined(&__NR_lsetxattr);
    eval 'sub SYS_lsetxattr () { &__NR_lsetxattr;}' unless defined(&SYS_lsetxattr);
    undef(&__NR_fsetxattr) if defined(&__NR_fsetxattr);
    eval 'sub __NR_fsetxattr () {(0+228);}' unless defined(&__NR_fsetxattr);
    eval 'sub SYS_fsetxattr () { &__NR_fsetxattr;}' unless defined(&SYS_fsetxattr);
    undef(&__NR_getxattr) if defined(&__NR_getxattr);
    eval 'sub __NR_getxattr () {(0+229);}' unless defined(&__NR_getxattr);
    eval 'sub SYS_getxattr () { &__NR_getxattr;}' unless defined(&SYS_getxattr);
    undef(&__NR_lgetxattr) if defined(&__NR_lgetxattr);
    eval 'sub __NR_lgetxattr () {(0+230);}' unless defined(&__NR_lgetxattr);
    eval 'sub SYS_lgetxattr () { &__NR_lgetxattr;}' unless defined(&SYS_lgetxattr);
    undef(&__NR_fgetxattr) if defined(&__NR_fgetxattr);
    eval 'sub __NR_fgetxattr () {(0+231);}' unless defined(&__NR_fgetxattr);
    eval 'sub SYS_fgetxattr () { &__NR_fgetxattr;}' unless defined(&SYS_fgetxattr);
    undef(&__NR_listxattr) if defined(&__NR_listxattr);
    eval 'sub __NR_listxattr () {(0+232);}' unless defined(&__NR_listxattr);
    eval 'sub SYS_listxattr () { &__NR_listxattr;}' unless defined(&SYS_listxattr);
    undef(&__NR_llistxattr) if defined(&__NR_llistxattr);
    eval 'sub __NR_llistxattr () {(0+233);}' unless defined(&__NR_llistxattr);
    eval 'sub SYS_llistxattr () { &__NR_llistxattr;}' unless defined(&SYS_llistxattr);
    undef(&__NR_flistxattr) if defined(&__NR_flistxattr);
    eval 'sub __NR_flistxattr () {(0+234);}' unless defined(&__NR_flistxattr);
    eval 'sub SYS_flistxattr () { &__NR_flistxattr;}' unless defined(&SYS_flistxattr);
    undef(&__NR_removexattr) if defined(&__NR_removexattr);
    eval 'sub __NR_removexattr () {(0+235);}' unless defined(&__NR_removexattr);
    eval 'sub SYS_removexattr () { &__NR_removexattr;}' unless defined(&SYS_removexattr);
    undef(&__NR_lremovexattr) if defined(&__NR_lremovexattr);
    eval 'sub __NR_lremovexattr () {(0+236);}' unless defined(&__NR_lremovexattr);
    eval 'sub SYS_lremovexattr () { &__NR_lremovexattr;}' unless defined(&SYS_lremovexattr);
    undef(&__NR_fremovexattr) if defined(&__NR_fremovexattr);
    eval 'sub __NR_fremovexattr () {(0+237);}' unless defined(&__NR_fremovexattr);
    eval 'sub SYS_fremovexattr () { &__NR_fremovexattr;}' unless defined(&SYS_fremovexattr);
    undef(&__NR_tkill) if defined(&__NR_tkill);
    eval 'sub __NR_tkill () {(0+238);}' unless defined(&__NR_tkill);
    eval 'sub SYS_tkill () { &__NR_tkill;}' unless defined(&SYS_tkill);
    undef(&__NR_sendfile64) if defined(&__NR_sendfile64);
    eval 'sub __NR_sendfile64 () {(0+239);}' unless defined(&__NR_sendfile64);
    eval 'sub SYS_sendfile64 () { &__NR_sendfile64;}' unless defined(&SYS_sendfile64);
    undef(&__NR_futex) if defined(&__NR_futex);
    eval 'sub __NR_futex () {(0+240);}' unless defined(&__NR_futex);
    eval 'sub SYS_futex () { &__NR_futex;}' unless defined(&SYS_futex);
    undef(&__NR_sched_setaffinity) if defined(&__NR_sched_setaffinity);
    eval 'sub __NR_sched_setaffinity () {(0+241);}' unless defined(&__NR_sched_setaffinity);
    eval 'sub SYS_sched_setaffinity () { &__NR_sched_setaffinity;}' unless defined(&SYS_sched_setaffinity);
    undef(&__NR_sched_getaffinity) if defined(&__NR_sched_getaffinity);
    eval 'sub __NR_sched_getaffinity () {(0+242);}' unless defined(&__NR_sched_getaffinity);
    eval 'sub SYS_sched_getaffinity () { &__NR_sched_getaffinity;}' unless defined(&SYS_sched_getaffinity);
    undef(&__NR_io_setup) if defined(&__NR_io_setup);
    eval 'sub __NR_io_setup () {(0+243);}' unless defined(&__NR_io_setup);
    eval 'sub SYS_io_setup () { &__NR_io_setup;}' unless defined(&SYS_io_setup);
    undef(&__NR_io_destroy) if defined(&__NR_io_destroy);
    eval 'sub __NR_io_destroy () {(0+244);}' unless defined(&__NR_io_destroy);
    eval 'sub SYS_io_destroy () { &__NR_io_destroy;}' unless defined(&SYS_io_destroy);
    undef(&__NR_io_getevents) if defined(&__NR_io_getevents);
    eval 'sub __NR_io_getevents () {(0+245);}' unless defined(&__NR_io_getevents);
    eval 'sub SYS_io_getevents () { &__NR_io_getevents;}' unless defined(&SYS_io_getevents);
    undef(&__NR_io_submit) if defined(&__NR_io_submit);
    eval 'sub __NR_io_submit () {(0+246);}' unless defined(&__NR_io_submit);
    eval 'sub SYS_io_submit () { &__NR_io_submit;}' unless defined(&SYS_io_submit);
    undef(&__NR_io_cancel) if defined(&__NR_io_cancel);
    eval 'sub __NR_io_cancel () {(0+247);}' unless defined(&__NR_io_cancel);
    eval 'sub SYS_io_cancel () { &__NR_io_cancel;}' unless defined(&SYS_io_cancel);
    undef(&__NR_exit_group) if defined(&__NR_exit_group);
    eval 'sub __NR_exit_group () {(0+248);}' unless defined(&__NR_exit_group);
    eval 'sub SYS_exit_group () { &__NR_exit_group;}' unless defined(&SYS_exit_group);
    undef(&__NR_lookup_dcookie) if defined(&__NR_lookup_dcookie);
    eval 'sub __NR_lookup_dcookie () {(0+249);}' unless defined(&__NR_lookup_dcookie);
    eval 'sub SYS_lookup_dcookie () { &__NR_lookup_dcookie;}' unless defined(&SYS_lookup_dcookie);
    undef(&__NR_epoll_create) if defined(&__NR_epoll_create);
    eval 'sub __NR_epoll_create () {(0+250);}' unless defined(&__NR_epoll_create);
    eval 'sub SYS_epoll_create () { &__NR_epoll_create;}' unless defined(&SYS_epoll_create);
    undef(&__NR_epoll_ctl) if defined(&__NR_epoll_ctl);
    eval 'sub __NR_epoll_ctl () {(0+251);}' unless defined(&__NR_epoll_ctl);
    eval 'sub SYS_epoll_ctl () { &__NR_epoll_ctl;}' unless defined(&SYS_epoll_ctl);
    undef(&__NR_epoll_wait) if defined(&__NR_epoll_wait);
    eval 'sub __NR_epoll_wait () {(0+252);}' unless defined(&__NR_epoll_wait);
    eval 'sub SYS_epoll_wait () { &__NR_epoll_wait;}' unless defined(&SYS_epoll_wait);
    undef(&__NR_remap_file_pages) if defined(&__NR_remap_file_pages);
    eval 'sub __NR_remap_file_pages () {(0+253);}' unless defined(&__NR_remap_file_pages);
    eval 'sub SYS_remap_file_pages () { &__NR_remap_file_pages;}' unless defined(&SYS_remap_file_pages);
    undef(&__NR_set_tid_address) if defined(&__NR_set_tid_address);
    eval 'sub __NR_set_tid_address () {(0+256);}' unless defined(&__NR_set_tid_address);
    eval 'sub SYS_set_tid_address () { &__NR_set_tid_address;}' unless defined(&SYS_set_tid_address);
    undef(&__NR_timer_create) if defined(&__NR_timer_create);
    eval 'sub __NR_timer_create () {(0+257);}' unless defined(&__NR_timer_create);
    eval 'sub SYS_timer_create () { &__NR_timer_create;}' unless defined(&SYS_timer_create);
    undef(&__NR_timer_settime) if defined(&__NR_timer_settime);
    eval 'sub __NR_timer_settime () {(0+258);}' unless defined(&__NR_timer_settime);
    eval 'sub SYS_timer_settime () { &__NR_timer_settime;}' unless defined(&SYS_timer_settime);
    undef(&__NR_timer_gettime) if defined(&__NR_timer_gettime);
    eval 'sub __NR_timer_gettime () {(0+259);}' unless defined(&__NR_timer_gettime);
    eval 'sub SYS_timer_gettime () { &__NR_timer_gettime;}' unless defined(&SYS_timer_gettime);
    undef(&__NR_timer_getoverrun) if defined(&__NR_timer_getoverrun);
    eval 'sub __NR_timer_getoverrun () {(0+260);}' unless defined(&__NR_timer_getoverrun);
    eval 'sub SYS_timer_getoverrun () { &__NR_timer_getoverrun;}' unless defined(&SYS_timer_getoverrun);
    undef(&__NR_timer_delete) if defined(&__NR_timer_delete);
    eval 'sub __NR_timer_delete () {(0+261);}' unless defined(&__NR_timer_delete);
    eval 'sub SYS_timer_delete () { &__NR_timer_delete;}' unless defined(&SYS_timer_delete);
    undef(&__NR_clock_settime) if defined(&__NR_clock_settime);
    eval 'sub __NR_clock_settime () {(0+262);}' unless defined(&__NR_clock_settime);
    eval 'sub SYS_clock_settime () { &__NR_clock_settime;}' unless defined(&SYS_clock_settime);
    undef(&__NR_clock_gettime) if defined(&__NR_clock_gettime);
    eval 'sub __NR_clock_gettime () {(0+263);}' unless defined(&__NR_clock_gettime);
    eval 'sub SYS_clock_gettime () { &__NR_clock_gettime;}' unless defined(&SYS_clock_gettime);
    undef(&__NR_clock_getres) if defined(&__NR_clock_getres);
    eval 'sub __NR_clock_getres () {(0+264);}' unless defined(&__NR_clock_getres);
    eval 'sub SYS_clock_getres () { &__NR_clock_getres;}' unless defined(&SYS_clock_getres);
    undef(&__NR_clock_nanosleep) if defined(&__NR_clock_nanosleep);
    eval 'sub __NR_clock_nanosleep () {(0+265);}' unless defined(&__NR_clock_nanosleep);
    eval 'sub SYS_clock_nanosleep () { &__NR_clock_nanosleep;}' unless defined(&SYS_clock_nanosleep);
    undef(&__NR_statfs64) if defined(&__NR_statfs64);
    eval 'sub __NR_statfs64 () {(0+266);}' unless defined(&__NR_statfs64);
    eval 'sub SYS_statfs64 () { &__NR_statfs64;}' unless defined(&SYS_statfs64);
    undef(&__NR_fstatfs64) if defined(&__NR_fstatfs64);
    eval 'sub __NR_fstatfs64 () {(0+267);}' unless defined(&__NR_fstatfs64);
    eval 'sub SYS_fstatfs64 () { &__NR_fstatfs64;}' unless defined(&SYS_fstatfs64);
    undef(&__NR_tgkill) if defined(&__NR_tgkill);
    eval 'sub __NR_tgkill () {(0+268);}' unless defined(&__NR_tgkill);
    eval 'sub SYS_tgkill () { &__NR_tgkill;}' unless defined(&SYS_tgkill);
    undef(&__NR_utimes) if defined(&__NR_utimes);
    eval 'sub __NR_utimes () {(0+269);}' unless defined(&__NR_utimes);
    eval 'sub SYS_utimes () { &__NR_utimes;}' unless defined(&SYS_utimes);
    undef(&__NR_arm_fadvise64_64) if defined(&__NR_arm_fadvise64_64);
    eval 'sub __NR_arm_fadvise64_64 () {(0+270);}' unless defined(&__NR_arm_fadvise64_64);
    eval 'sub SYS_arm_fadvise64_64 () { &__NR_arm_fadvise64_64;}' unless defined(&SYS_arm_fadvise64_64);
    undef(&__NR_pciconfig_iobase) if defined(&__NR_pciconfig_iobase);
    eval 'sub __NR_pciconfig_iobase () {(0+271);}' unless defined(&__NR_pciconfig_iobase);
    eval 'sub SYS_pciconfig_iobase () { &__NR_pciconfig_iobase;}' unless defined(&SYS_pciconfig_iobase);
    undef(&__NR_pciconfig_read) if defined(&__NR_pciconfig_read);
    eval 'sub __NR_pciconfig_read () {(0+272);}' unless defined(&__NR_pciconfig_read);
    eval 'sub SYS_pciconfig_read () { &__NR_pciconfig_read;}' unless defined(&SYS_pciconfig_read);
    undef(&__NR_pciconfig_write) if defined(&__NR_pciconfig_write);
    eval 'sub __NR_pciconfig_write () {(0+273);}' unless defined(&__NR_pciconfig_write);
    eval 'sub SYS_pciconfig_write () { &__NR_pciconfig_write;}' unless defined(&SYS_pciconfig_write);
    undef(&__NR_mq_open) if defined(&__NR_mq_open);
    eval 'sub __NR_mq_open () {(0+274);}' unless defined(&__NR_mq_open);
    eval 'sub SYS_mq_open () { &__NR_mq_open;}' unless defined(&SYS_mq_open);
    undef(&__NR_mq_unlink) if defined(&__NR_mq_unlink);
    eval 'sub __NR_mq_unlink () {(0+275);}' unless defined(&__NR_mq_unlink);
    eval 'sub SYS_mq_unlink () { &__NR_mq_unlink;}' unless defined(&SYS_mq_unlink);
    undef(&__NR_mq_timedsend) if defined(&__NR_mq_timedsend);
    eval 'sub __NR_mq_timedsend () {(0+276);}' unless defined(&__NR_mq_timedsend);
    eval 'sub SYS_mq_timedsend () { &__NR_mq_timedsend;}' unless defined(&SYS_mq_timedsend);
    undef(&__NR_mq_timedreceive) if defined(&__NR_mq_timedreceive);
    eval 'sub __NR_mq_timedreceive () {(0+277);}' unless defined(&__NR_mq_timedreceive);
    eval 'sub SYS_mq_timedreceive () { &__NR_mq_timedreceive;}' unless defined(&SYS_mq_timedreceive);
    undef(&__NR_mq_notify) if defined(&__NR_mq_notify);
    eval 'sub __NR_mq_notify () {(0+278);}' unless defined(&__NR_mq_notify);
    eval 'sub SYS_mq_notify () { &__NR_mq_notify;}' unless defined(&SYS_mq_notify);
    undef(&__NR_mq_getsetattr) if defined(&__NR_mq_getsetattr);
    eval 'sub __NR_mq_getsetattr () {(0+279);}' unless defined(&__NR_mq_getsetattr);
    eval 'sub SYS_mq_getsetattr () { &__NR_mq_getsetattr;}' unless defined(&SYS_mq_getsetattr);
    undef(&__NR_waitid) if defined(&__NR_waitid);
    eval 'sub __NR_waitid () {(0+280);}' unless defined(&__NR_waitid);
    eval 'sub SYS_waitid () { &__NR_waitid;}' unless defined(&SYS_waitid);
    undef(&__NR_socket) if defined(&__NR_socket);
    eval 'sub __NR_socket () {(0+281);}' unless defined(&__NR_socket);
    eval 'sub SYS_socket () { &__NR_socket;}' unless defined(&SYS_socket);
    undef(&__NR_bind) if defined(&__NR_bind);
    eval 'sub __NR_bind () {(0+282);}' unless defined(&__NR_bind);
    eval 'sub SYS_bind () { &__NR_bind;}' unless defined(&SYS_bind);
    undef(&__NR_connect) if defined(&__NR_connect);
    eval 'sub __NR_connect () {(0+283);}' unless defined(&__NR_connect);
    eval 'sub SYS_connect () { &__NR_connect;}' unless defined(&SYS_connect);
    undef(&__NR_listen) if defined(&__NR_listen);
    eval 'sub __NR_listen () {(0+284);}' unless defined(&__NR_listen);
    eval 'sub SYS_listen () { &__NR_listen;}' unless defined(&SYS_listen);
    undef(&__NR_accept) if defined(&__NR_accept);
    eval 'sub __NR_accept () {(0+285);}' unless defined(&__NR_accept);
    eval 'sub SYS_accept () { &__NR_accept;}' unless defined(&SYS_accept);
    undef(&__NR_getsockname) if defined(&__NR_getsockname);
    eval 'sub __NR_getsockname () {(0+286);}' unless defined(&__NR_getsockname);
    eval 'sub SYS_getsockname () { &__NR_getsockname;}' unless defined(&SYS_getsockname);
    undef(&__NR_getpeername) if defined(&__NR_getpeername);
    eval 'sub __NR_getpeername () {(0+287);}' unless defined(&__NR_getpeername);
    eval 'sub SYS_getpeername () { &__NR_getpeername;}' unless defined(&SYS_getpeername);
    undef(&__NR_socketpair) if defined(&__NR_socketpair);
    eval 'sub __NR_socketpair () {(0+288);}' unless defined(&__NR_socketpair);
    eval 'sub SYS_socketpair () { &__NR_socketpair;}' unless defined(&SYS_socketpair);
    undef(&__NR_send) if defined(&__NR_send);
    eval 'sub __NR_send () {(0+289);}' unless defined(&__NR_send);
    eval 'sub SYS_send () { &__NR_send;}' unless defined(&SYS_send);
    undef(&__NR_sendto) if defined(&__NR_sendto);
    eval 'sub __NR_sendto () {(0+290);}' unless defined(&__NR_sendto);
    eval 'sub SYS_sendto () { &__NR_sendto;}' unless defined(&SYS_sendto);
    undef(&__NR_recv) if defined(&__NR_recv);
    eval 'sub __NR_recv () {(0+291);}' unless defined(&__NR_recv);
    eval 'sub SYS_recv () { &__NR_recv;}' unless defined(&SYS_recv);
    undef(&__NR_recvfrom) if defined(&__NR_recvfrom);
    eval 'sub __NR_recvfrom () {(0+292);}' unless defined(&__NR_recvfrom);
    eval 'sub SYS_recvfrom () { &__NR_recvfrom;}' unless defined(&SYS_recvfrom);
    undef(&__NR_shutdown) if defined(&__NR_shutdown);
    eval 'sub __NR_shutdown () {(0+293);}' unless defined(&__NR_shutdown);
    eval 'sub SYS_shutdown () { &__NR_shutdown;}' unless defined(&SYS_shutdown);
    undef(&__NR_setsockopt) if defined(&__NR_setsockopt);
    eval 'sub __NR_setsockopt () {(0+294);}' unless defined(&__NR_setsockopt);
    eval 'sub SYS_setsockopt () { &__NR_setsockopt;}' unless defined(&SYS_setsockopt);
    undef(&__NR_getsockopt) if defined(&__NR_getsockopt);
    eval 'sub __NR_getsockopt () {(0+295);}' unless defined(&__NR_getsockopt);
    eval 'sub SYS_getsockopt () { &__NR_getsockopt;}' unless defined(&SYS_getsockopt);
    undef(&__NR_sendmsg) if defined(&__NR_sendmsg);
    eval 'sub __NR_sendmsg () {(0+296);}' unless defined(&__NR_sendmsg);
    eval 'sub SYS_sendmsg () { &__NR_sendmsg;}' unless defined(&SYS_sendmsg);
    undef(&__NR_recvmsg) if defined(&__NR_recvmsg);
    eval 'sub __NR_recvmsg () {(0+297);}' unless defined(&__NR_recvmsg);
    eval 'sub SYS_recvmsg () { &__NR_recvmsg;}' unless defined(&SYS_recvmsg);
    undef(&__NR_semop) if defined(&__NR_semop);
    eval 'sub __NR_semop () {(0+298);}' unless defined(&__NR_semop);
    eval 'sub SYS_semop () { &__NR_semop;}' unless defined(&SYS_semop);
    undef(&__NR_semget) if defined(&__NR_semget);
    eval 'sub __NR_semget () {(0+299);}' unless defined(&__NR_semget);
    eval 'sub SYS_semget () { &__NR_semget;}' unless defined(&SYS_semget);
    undef(&__NR_semctl) if defined(&__NR_semctl);
    eval 'sub __NR_semctl () {(0+300);}' unless defined(&__NR_semctl);
    eval 'sub SYS_semctl () { &__NR_semctl;}' unless defined(&SYS_semctl);
    undef(&__NR_msgsnd) if defined(&__NR_msgsnd);
    eval 'sub __NR_msgsnd () {(0+301);}' unless defined(&__NR_msgsnd);
    eval 'sub SYS_msgsnd () { &__NR_msgsnd;}' unless defined(&SYS_msgsnd);
    undef(&__NR_msgrcv) if defined(&__NR_msgrcv);
    eval 'sub __NR_msgrcv () {(0+302);}' unless defined(&__NR_msgrcv);
    eval 'sub SYS_msgrcv () { &__NR_msgrcv;}' unless defined(&SYS_msgrcv);
    undef(&__NR_msgget) if defined(&__NR_msgget);
    eval 'sub __NR_msgget () {(0+303);}' unless defined(&__NR_msgget);
    eval 'sub SYS_msgget () { &__NR_msgget;}' unless defined(&SYS_msgget);
    undef(&__NR_msgctl) if defined(&__NR_msgctl);
    eval 'sub __NR_msgctl () {(0+304);}' unless defined(&__NR_msgctl);
    eval 'sub SYS_msgctl () { &__NR_msgctl;}' unless defined(&SYS_msgctl);
    undef(&__NR_shmat) if defined(&__NR_shmat);
    eval 'sub __NR_shmat () {(0+305);}' unless defined(&__NR_shmat);
    eval 'sub SYS_shmat () { &__NR_shmat;}' unless defined(&SYS_shmat);
    undef(&__NR_shmdt) if defined(&__NR_shmdt);
    eval 'sub __NR_shmdt () {(0+306);}' unless defined(&__NR_shmdt);
    eval 'sub SYS_shmdt () { &__NR_shmdt;}' unless defined(&SYS_shmdt);
    undef(&__NR_shmget) if defined(&__NR_shmget);
    eval 'sub __NR_shmget () {(0+307);}' unless defined(&__NR_shmget);
    eval 'sub SYS_shmget () { &__NR_shmget;}' unless defined(&SYS_shmget);
    undef(&__NR_shmctl) if defined(&__NR_shmctl);
    eval 'sub __NR_shmctl () {(0+308);}' unless defined(&__NR_shmctl);
    eval 'sub SYS_shmctl () { &__NR_shmctl;}' unless defined(&SYS_shmctl);
    undef(&__NR_add_key) if defined(&__NR_add_key);
    eval 'sub __NR_add_key () {(0+309);}' unless defined(&__NR_add_key);
    eval 'sub SYS_add_key () { &__NR_add_key;}' unless defined(&SYS_add_key);
    undef(&__NR_request_key) if defined(&__NR_request_key);
    eval 'sub __NR_request_key () {(0+310);}' unless defined(&__NR_request_key);
    eval 'sub SYS_request_key () { &__NR_request_key;}' unless defined(&SYS_request_key);
    undef(&__NR_keyctl) if defined(&__NR_keyctl);
    eval 'sub __NR_keyctl () {(0+311);}' unless defined(&__NR_keyctl);
    eval 'sub SYS_keyctl () { &__NR_keyctl;}' unless defined(&SYS_keyctl);
    undef(&__NR_semtimedop) if defined(&__NR_semtimedop);
    eval 'sub __NR_semtimedop () {(0+312);}' unless defined(&__NR_semtimedop);
    eval 'sub SYS_semtimedop () { &__NR_semtimedop;}' unless defined(&SYS_semtimedop);
    undef(&__NR_vserver) if defined(&__NR_vserver);
    eval 'sub __NR_vserver () {(0+313);}' unless defined(&__NR_vserver);
    eval 'sub SYS_vserver () { &__NR_vserver;}' unless defined(&SYS_vserver);
    undef(&__NR_ioprio_set) if defined(&__NR_ioprio_set);
    eval 'sub __NR_ioprio_set () {(0+314);}' unless defined(&__NR_ioprio_set);
    eval 'sub SYS_ioprio_set () { &__NR_ioprio_set;}' unless defined(&SYS_ioprio_set);
    undef(&__NR_ioprio_get) if defined(&__NR_ioprio_get);
    eval 'sub __NR_ioprio_get () {(0+315);}' unless defined(&__NR_ioprio_get);
    eval 'sub SYS_ioprio_get () { &__NR_ioprio_get;}' unless defined(&SYS_ioprio_get);
    undef(&__NR_inotify_init) if defined(&__NR_inotify_init);
    eval 'sub __NR_inotify_init () {(0+316);}' unless defined(&__NR_inotify_init);
    eval 'sub SYS_inotify_init () { &__NR_inotify_init;}' unless defined(&SYS_inotify_init);
    undef(&__NR_inotify_add_watch) if defined(&__NR_inotify_add_watch);
    eval 'sub __NR_inotify_add_watch () {(0+317);}' unless defined(&__NR_inotify_add_watch);
    eval 'sub SYS_inotify_add_watch () { &__NR_inotify_add_watch;}' unless defined(&SYS_inotify_add_watch);
    undef(&__NR_inotify_rm_watch) if defined(&__NR_inotify_rm_watch);
    eval 'sub __NR_inotify_rm_watch () {(0+318);}' unless defined(&__NR_inotify_rm_watch);
    eval 'sub SYS_inotify_rm_watch () { &__NR_inotify_rm_watch;}' unless defined(&SYS_inotify_rm_watch);
    undef(&__NR_mbind) if defined(&__NR_mbind);
    eval 'sub __NR_mbind () {(0+319);}' unless defined(&__NR_mbind);
    eval 'sub SYS_mbind () { &__NR_mbind;}' unless defined(&SYS_mbind);
    undef(&__NR_get_mempolicy) if defined(&__NR_get_mempolicy);
    eval 'sub __NR_get_mempolicy () {(0+320);}' unless defined(&__NR_get_mempolicy);
    eval 'sub SYS_get_mempolicy () { &__NR_get_mempolicy;}' unless defined(&SYS_get_mempolicy);
    undef(&__NR_set_mempolicy) if defined(&__NR_set_mempolicy);
    eval 'sub __NR_set_mempolicy () {(0+321);}' unless defined(&__NR_set_mempolicy);
    eval 'sub SYS_set_mempolicy () { &__NR_set_mempolicy;}' unless defined(&SYS_set_mempolicy);
    undef(&__NR_openat) if defined(&__NR_openat);
    eval 'sub __NR_openat () {(0+322);}' unless defined(&__NR_openat);
    eval 'sub SYS_openat () { &__NR_openat;}' unless defined(&SYS_openat);
    undef(&__NR_mkdirat) if defined(&__NR_mkdirat);
    eval 'sub __NR_mkdirat () {(0+323);}' unless defined(&__NR_mkdirat);
    eval 'sub SYS_mkdirat () { &__NR_mkdirat;}' unless defined(&SYS_mkdirat);
    undef(&__NR_mknodat) if defined(&__NR_mknodat);
    eval 'sub __NR_mknodat () {(0+324);}' unless defined(&__NR_mknodat);
    eval 'sub SYS_mknodat () { &__NR_mknodat;}' unless defined(&SYS_mknodat);
    undef(&__NR_fchownat) if defined(&__NR_fchownat);
    eval 'sub __NR_fchownat () {(0+325);}' unless defined(&__NR_fchownat);
    eval 'sub SYS_fchownat () { &__NR_fchownat;}' unless defined(&SYS_fchownat);
    undef(&__NR_futimesat) if defined(&__NR_futimesat);
    eval 'sub __NR_futimesat () {(0+326);}' unless defined(&__NR_futimesat);
    eval 'sub SYS_futimesat () { &__NR_futimesat;}' unless defined(&SYS_futimesat);
    undef(&__NR_fstatat64) if defined(&__NR_fstatat64);
    eval 'sub __NR_fstatat64 () {(0+327);}' unless defined(&__NR_fstatat64);
    eval 'sub SYS_fstatat64 () { &__NR_fstatat64;}' unless defined(&SYS_fstatat64);
    undef(&__NR_unlinkat) if defined(&__NR_unlinkat);
    eval 'sub __NR_unlinkat () {(0+328);}' unless defined(&__NR_unlinkat);
    eval 'sub SYS_unlinkat () { &__NR_unlinkat;}' unless defined(&SYS_unlinkat);
    undef(&__NR_renameat) if defined(&__NR_renameat);
    eval 'sub __NR_renameat () {(0+329);}' unless defined(&__NR_renameat);
    eval 'sub SYS_renameat () { &__NR_renameat;}' unless defined(&SYS_renameat);
    undef(&__NR_linkat) if defined(&__NR_linkat);
    eval 'sub __NR_linkat () {(0+330);}' unless defined(&__NR_linkat);
    eval 'sub SYS_linkat () { &__NR_linkat;}' unless defined(&SYS_linkat);
    undef(&__NR_symlinkat) if defined(&__NR_symlinkat);
    eval 'sub __NR_symlinkat () {(0+331);}' unless defined(&__NR_symlinkat);
    eval 'sub SYS_symlinkat () { &__NR_symlinkat;}' unless defined(&SYS_symlinkat);
    undef(&__NR_readlinkat) if defined(&__NR_readlinkat);
    eval 'sub __NR_readlinkat () {(0+332);}' unless defined(&__NR_readlinkat);
    eval 'sub SYS_readlinkat () { &__NR_readlinkat;}' unless defined(&SYS_readlinkat);
    undef(&__NR_fchmodat) if defined(&__NR_fchmodat);
    eval 'sub __NR_fchmodat () {(0+333);}' unless defined(&__NR_fchmodat);
    eval 'sub SYS_fchmodat () { &__NR_fchmodat;}' unless defined(&SYS_fchmodat);
    undef(&__NR_faccessat) if defined(&__NR_faccessat);
    eval 'sub __NR_faccessat () {(0+334);}' unless defined(&__NR_faccessat);
    eval 'sub SYS_faccessat () { &__NR_faccessat;}' unless defined(&SYS_faccessat);
    undef(&__NR_pselect6) if defined(&__NR_pselect6);
    eval 'sub __NR_pselect6 () {(0+335);}' unless defined(&__NR_pselect6);
    eval 'sub SYS_pselect6 () { &__NR_pselect6;}' unless defined(&SYS_pselect6);
    undef(&__NR_ppoll) if defined(&__NR_ppoll);
    eval 'sub __NR_ppoll () {(0+336);}' unless defined(&__NR_ppoll);
    eval 'sub SYS_ppoll () { &__NR_ppoll;}' unless defined(&SYS_ppoll);
    undef(&__NR_unshare) if defined(&__NR_unshare);
    eval 'sub __NR_unshare () {(0+337);}' unless defined(&__NR_unshare);
    eval 'sub SYS_unshare () { &__NR_unshare;}' unless defined(&SYS_unshare);
    undef(&__NR_set_robust_list) if defined(&__NR_set_robust_list);
    eval 'sub __NR_set_robust_list () {(0+338);}' unless defined(&__NR_set_robust_list);
    eval 'sub SYS_set_robust_list () { &__NR_set_robust_list;}' unless defined(&SYS_set_robust_list);
    undef(&__NR_get_robust_list) if defined(&__NR_get_robust_list);
    eval 'sub __NR_get_robust_list () {(0+339);}' unless defined(&__NR_get_robust_list);
    eval 'sub SYS_get_robust_list () { &__NR_get_robust_list;}' unless defined(&SYS_get_robust_list);
    undef(&__NR_splice) if defined(&__NR_splice);
    eval 'sub __NR_splice () {(0+340);}' unless defined(&__NR_splice);
    eval 'sub SYS_splice () { &__NR_splice;}' unless defined(&SYS_splice);
    undef(&__NR_arm_sync_file_range) if defined(&__NR_arm_sync_file_range);
    eval 'sub __NR_arm_sync_file_range () {(0+341);}' unless defined(&__NR_arm_sync_file_range);
    eval 'sub SYS_arm_sync_file_range () { &__NR_arm_sync_file_range;}' unless defined(&SYS_arm_sync_file_range);
    undef(&__NR_sync_file_range2) if defined(&__NR_sync_file_range2);
    eval 'sub __NR_sync_file_range2 () {(0+341);}' unless defined(&__NR_sync_file_range2);
    eval 'sub SYS_sync_file_range2 () { &__NR_sync_file_range2;}' unless defined(&SYS_sync_file_range2);
    undef(&__NR_tee) if defined(&__NR_tee);
    eval 'sub __NR_tee () {(0+342);}' unless defined(&__NR_tee);
    eval 'sub SYS_tee () { &__NR_tee;}' unless defined(&SYS_tee);
    undef(&__NR_vmsplice) if defined(&__NR_vmsplice);
    eval 'sub __NR_vmsplice () {(0+343);}' unless defined(&__NR_vmsplice);
    eval 'sub SYS_vmsplice () { &__NR_vmsplice;}' unless defined(&SYS_vmsplice);
    undef(&__NR_move_pages) if defined(&__NR_move_pages);
    eval 'sub __NR_move_pages () {(0+344);}' unless defined(&__NR_move_pages);
    eval 'sub SYS_move_pages () { &__NR_move_pages;}' unless defined(&SYS_move_pages);
    undef(&__NR_getcpu) if defined(&__NR_getcpu);
    eval 'sub __NR_getcpu () {(0+345);}' unless defined(&__NR_getcpu);
    eval 'sub SYS_getcpu () { &__NR_getcpu;}' unless defined(&SYS_getcpu);
    undef(&__NR_epoll_pwait) if defined(&__NR_epoll_pwait);
    eval 'sub __NR_epoll_pwait () {(0+346);}' unless defined(&__NR_epoll_pwait);
    eval 'sub SYS_epoll_pwait () { &__NR_epoll_pwait;}' unless defined(&SYS_epoll_pwait);
    undef(&__NR_kexec_load) if defined(&__NR_kexec_load);
    eval 'sub __NR_kexec_load () {(0+347);}' unless defined(&__NR_kexec_load);
    eval 'sub SYS_kexec_load () { &__NR_kexec_load;}' unless defined(&SYS_kexec_load);
    undef(&__NR_utimensat) if defined(&__NR_utimensat);
    eval 'sub __NR_utimensat () {(0+348);}' unless defined(&__NR_utimensat);
    eval 'sub SYS_utimensat () { &__NR_utimensat;}' unless defined(&SYS_utimensat);
    undef(&__NR_signalfd) if defined(&__NR_signalfd);
    eval 'sub __NR_signalfd () {(0+349);}' unless defined(&__NR_signalfd);
    eval 'sub SYS_signalfd () { &__NR_signalfd;}' unless defined(&SYS_signalfd);
    undef(&__NR_timerfd_create) if defined(&__NR_timerfd_create);
    eval 'sub __NR_timerfd_create () {(0+350);}' unless defined(&__NR_timerfd_create);
    eval 'sub SYS_timerfd_create () { &__NR_timerfd_create;}' unless defined(&SYS_timerfd_create);
    undef(&__NR_eventfd) if defined(&__NR_eventfd);
    eval 'sub __NR_eventfd () {(0+351);}' unless defined(&__NR_eventfd);
    eval 'sub SYS_eventfd () { &__NR_eventfd;}' unless defined(&SYS_eventfd);
    undef(&__NR_fallocate) if defined(&__NR_fallocate);
    eval 'sub __NR_fallocate () {(0+352);}' unless defined(&__NR_fallocate);
    eval 'sub SYS_fallocate () { &__NR_fallocate;}' unless defined(&SYS_fallocate);
    undef(&__NR_timerfd_settime) if defined(&__NR_timerfd_settime);
    eval 'sub __NR_timerfd_settime () {(0+353);}' unless defined(&__NR_timerfd_settime);
    eval 'sub SYS_timerfd_settime () { &__NR_timerfd_settime;}' unless defined(&SYS_timerfd_settime);
    undef(&__NR_timerfd_gettime) if defined(&__NR_timerfd_gettime);
    eval 'sub __NR_timerfd_gettime () {(0+354);}' unless defined(&__NR_timerfd_gettime);
    eval 'sub SYS_timerfd_gettime () { &__NR_timerfd_gettime;}' unless defined(&SYS_timerfd_gettime);
    undef(&__NR_signalfd4) if defined(&__NR_signalfd4);
    eval 'sub __NR_signalfd4 () {(0+355);}' unless defined(&__NR_signalfd4);
    eval 'sub SYS_signalfd4 () { &__NR_signalfd4;}' unless defined(&SYS_signalfd4);
    undef(&__NR_eventfd2) if defined(&__NR_eventfd2);
    eval 'sub __NR_eventfd2 () {(0+356);}' unless defined(&__NR_eventfd2);
    eval 'sub SYS_eventfd2 () { &__NR_eventfd2;}' unless defined(&SYS_eventfd2);
    undef(&__NR_epoll_create1) if defined(&__NR_epoll_create1);
    eval 'sub __NR_epoll_create1 () {(0+357);}' unless defined(&__NR_epoll_create1);
    eval 'sub SYS_epoll_create1 () { &__NR_epoll_create1;}' unless defined(&SYS_epoll_create1);
    undef(&__NR_dup3) if defined(&__NR_dup3);
    eval 'sub __NR_dup3 () {(0+358);}' unless defined(&__NR_dup3);
    eval 'sub SYS_dup3 () { &__NR_dup3;}' unless defined(&SYS_dup3);
    undef(&__NR_pipe2) if defined(&__NR_pipe2);
    eval 'sub __NR_pipe2 () {(0+359);}' unless defined(&__NR_pipe2);
    eval 'sub SYS_pipe2 () { &__NR_pipe2;}' unless defined(&SYS_pipe2);
    undef(&__NR_inotify_init1) if defined(&__NR_inotify_init1);
    eval 'sub __NR_inotify_init1 () {(0+360);}' unless defined(&__NR_inotify_init1);
    eval 'sub SYS_inotify_init1 () { &__NR_inotify_init1;}' unless defined(&SYS_inotify_init1);
    undef(&__NR_preadv) if defined(&__NR_preadv);
    eval 'sub __NR_preadv () {(0+361);}' unless defined(&__NR_preadv);
    eval 'sub SYS_preadv () { &__NR_preadv;}' unless defined(&SYS_preadv);
    undef(&__NR_pwritev) if defined(&__NR_pwritev);
    eval 'sub __NR_pwritev () {(0+362);}' unless defined(&__NR_pwritev);
    eval 'sub SYS_pwritev () { &__NR_pwritev;}' unless defined(&SYS_pwritev);
    undef(&__NR_rt_tgsigqueueinfo) if defined(&__NR_rt_tgsigqueueinfo);
    eval 'sub __NR_rt_tgsigqueueinfo () {(0+363);}' unless defined(&__NR_rt_tgsigqueueinfo);
    eval 'sub SYS_rt_tgsigqueueinfo () { &__NR_rt_tgsigqueueinfo;}' unless defined(&SYS_rt_tgsigqueueinfo);
    undef(&__NR_perf_event_open) if defined(&__NR_perf_event_open);
    eval 'sub __NR_perf_event_open () {(0+364);}' unless defined(&__NR_perf_event_open);
    eval 'sub SYS_perf_event_open () { &__NR_perf_event_open;}' unless defined(&SYS_perf_event_open);
    undef(&__NR_recvmmsg) if defined(&__NR_recvmmsg);
    eval 'sub __NR_recvmmsg () {(0+365);}' unless defined(&__NR_recvmmsg);
    eval 'sub SYS_recvmmsg () { &__NR_recvmmsg;}' unless defined(&SYS_recvmmsg);
    undef(&__NR_accept4) if defined(&__NR_accept4);
    eval 'sub __NR_accept4 () {(0+366);}' unless defined(&__NR_accept4);
    eval 'sub SYS_accept4 () { &__NR_accept4;}' unless defined(&SYS_accept4);
    undef(&__NR_fanotify_init) if defined(&__NR_fanotify_init);
    eval 'sub __NR_fanotify_init () {(0+367);}' unless defined(&__NR_fanotify_init);
    eval 'sub SYS_fanotify_init () { &__NR_fanotify_init;}' unless defined(&SYS_fanotify_init);
    undef(&__NR_fanotify_mark) if defined(&__NR_fanotify_mark);
    eval 'sub __NR_fanotify_mark () {(0+368);}' unless defined(&__NR_fanotify_mark);
    eval 'sub SYS_fanotify_mark () { &__NR_fanotify_mark;}' unless defined(&SYS_fanotify_mark);
    undef(&__NR_prlimit64) if defined(&__NR_prlimit64);
    eval 'sub __NR_prlimit64 () {(0+369);}' unless defined(&__NR_prlimit64);
    eval 'sub SYS_prlimit64 () { &__NR_prlimit64;}' unless defined(&SYS_prlimit64);
    undef(&__NR_name_to_handle_at) if defined(&__NR_name_to_handle_at);
    eval 'sub __NR_name_to_handle_at () {(0+370);}' unless defined(&__NR_name_to_handle_at);
    eval 'sub SYS_name_to_handle_at () { &__NR_name_to_handle_at;}' unless defined(&SYS_name_to_handle_at);
    undef(&__NR_open_by_handle_at) if defined(&__NR_open_by_handle_at);
    eval 'sub __NR_open_by_handle_at () {(0+371);}' unless defined(&__NR_open_by_handle_at);
    eval 'sub SYS_open_by_handle_at () { &__NR_open_by_handle_at;}' unless defined(&SYS_open_by_handle_at);
    undef(&__NR_clock_adjtime) if defined(&__NR_clock_adjtime);
    eval 'sub __NR_clock_adjtime () {(0+372);}' unless defined(&__NR_clock_adjtime);
    eval 'sub SYS_clock_adjtime () { &__NR_clock_adjtime;}' unless defined(&SYS_clock_adjtime);
    undef(&__NR_syncfs) if defined(&__NR_syncfs);
    eval 'sub __NR_syncfs () {(0+373);}' unless defined(&__NR_syncfs);
    eval 'sub SYS_syncfs () { &__NR_syncfs;}' unless defined(&SYS_syncfs);
    undef(&__NR_sendmmsg) if defined(&__NR_sendmmsg);
    eval 'sub __NR_sendmmsg () {(0+374);}' unless defined(&__NR_sendmmsg);
    eval 'sub SYS_sendmmsg () { &__NR_sendmmsg;}' unless defined(&SYS_sendmmsg);
    undef(&__NR_setns) if defined(&__NR_setns);
    eval 'sub __NR_setns () {(0+375);}' unless defined(&__NR_setns);
    eval 'sub SYS_setns () { &__NR_setns;}' unless defined(&SYS_setns);
    undef(&__NR_process_vm_readv) if defined(&__NR_process_vm_readv);
    eval 'sub __NR_process_vm_readv () {(0+376);}' unless defined(&__NR_process_vm_readv);
    eval 'sub SYS_process_vm_readv () { &__NR_process_vm_readv;}' unless defined(&SYS_process_vm_readv);
    undef(&__NR_process_vm_writev) if defined(&__NR_process_vm_writev);
    eval 'sub __NR_process_vm_writev () {(0+377);}' unless defined(&__NR_process_vm_writev);
    eval 'sub SYS_process_vm_writev () { &__NR_process_vm_writev;}' unless defined(&SYS_process_vm_writev);
    undef(&__NR_kcmp) if defined(&__NR_kcmp);
    eval 'sub __NR_kcmp () {(0+378);}' unless defined(&__NR_kcmp);
    eval 'sub SYS_kcmp () { &__NR_kcmp;}' unless defined(&SYS_kcmp);
    undef(&__NR_finit_module) if defined(&__NR_finit_module);
    eval 'sub __NR_finit_module () {(0+379);}' unless defined(&__NR_finit_module);
    eval 'sub SYS_finit_module () { &__NR_finit_module;}' unless defined(&SYS_finit_module);
    undef(&__NR_sched_setattr) if defined(&__NR_sched_setattr);
    eval 'sub __NR_sched_setattr () {(0+380);}' unless defined(&__NR_sched_setattr);
    eval 'sub SYS_sched_setattr () { &__NR_sched_setattr;}' unless defined(&SYS_sched_setattr);
    undef(&__NR_sched_getattr) if defined(&__NR_sched_getattr);
    eval 'sub __NR_sched_getattr () {(0+381);}' unless defined(&__NR_sched_getattr);
    eval 'sub SYS_sched_getattr () { &__NR_sched_getattr;}' unless defined(&SYS_sched_getattr);
    undef(&__NR_renameat2) if defined(&__NR_renameat2);
    eval 'sub __NR_renameat2 () {(0+382);}' unless defined(&__NR_renameat2);
    eval 'sub SYS_renameat2 () { &__NR_renameat2;}' unless defined(&SYS_renameat2);
    undef(&__NR_seccomp) if defined(&__NR_seccomp);
    eval 'sub __NR_seccomp () {(0+383);}' unless defined(&__NR_seccomp);
    eval 'sub SYS_seccomp () { &__NR_seccomp;}' unless defined(&SYS_seccomp);
    undef(&__NR_getrandom) if defined(&__NR_getrandom);
    eval 'sub __NR_getrandom () {(0+384);}' unless defined(&__NR_getrandom);
    eval 'sub SYS_getrandom () { &__NR_getrandom;}' unless defined(&SYS_getrandom);
    undef(&__NR_memfd_create) if defined(&__NR_memfd_create);
    eval 'sub __NR_memfd_create () {(0+385);}' unless defined(&__NR_memfd_create);
    eval 'sub SYS_memfd_create () { &__NR_memfd_create;}' unless defined(&SYS_memfd_create);
    undef(&__NR_bpf) if defined(&__NR_bpf);
    eval 'sub __NR_bpf () {(0+386);}' unless defined(&__NR_bpf);
    eval 'sub SYS_bpf () { &__NR_bpf;}' unless defined(&SYS_bpf);
    undef(&__NR_execveat) if defined(&__NR_execveat);
    eval 'sub __NR_execveat () {(0+387);}' unless defined(&__NR_execveat);
    eval 'sub SYS_execveat () { &__NR_execveat;}' unless defined(&SYS_execveat);
    undef(&__NR_userfaultfd) if defined(&__NR_userfaultfd);
    eval 'sub __NR_userfaultfd () {(0+388);}' unless defined(&__NR_userfaultfd);
    eval 'sub SYS_userfaultfd () { &__NR_userfaultfd;}' unless defined(&SYS_userfaultfd);
    undef(&__NR_membarrier) if defined(&__NR_membarrier);
    eval 'sub __NR_membarrier () {(0+389);}' unless defined(&__NR_membarrier);
    eval 'sub SYS_membarrier () { &__NR_membarrier;}' unless defined(&SYS_membarrier);
    undef(&__ARM_NR_BASE) if defined(&__ARM_NR_BASE);
    eval 'sub __ARM_NR_BASE () {(0+0xf0000);}' unless defined(&__ARM_NR_BASE);
    eval 'sub SYS_BASE () { &__ARM_NR_BASE;}' unless defined(&SYS_BASE);
    undef(&__ARM_NR_breakpoint) if defined(&__ARM_NR_breakpoint);
    eval 'sub __ARM_NR_breakpoint () {((0+0xf0000)+1);}' unless defined(&__ARM_NR_breakpoint);
    eval 'sub SYS_breakpoint () { &__ARM_NR_breakpoint;}' unless defined(&SYS_breakpoint);
    undef(&__ARM_NR_cacheflush) if defined(&__ARM_NR_cacheflush);
    eval 'sub __ARM_NR_cacheflush () {((0+0xf0000)+2);}' unless defined(&__ARM_NR_cacheflush);
    eval 'sub SYS_cacheflush () { &__ARM_NR_cacheflush;}' unless defined(&SYS_cacheflush);
    undef(&__ARM_NR_usr26) if defined(&__ARM_NR_usr26);
    eval 'sub __ARM_NR_usr26 () {((0+0xf0000)+3);}' unless defined(&__ARM_NR_usr26);
    eval 'sub SYS_usr26 () { &__ARM_NR_usr26;}' unless defined(&SYS_usr26);
    undef(&__ARM_NR_usr32) if defined(&__ARM_NR_usr32);
    eval 'sub __ARM_NR_usr32 () {((0+0xf0000)+4);}' unless defined(&__ARM_NR_usr32);
    eval 'sub SYS_usr32 () { &__ARM_NR_usr32;}' unless defined(&SYS_usr32);
    undef(&__ARM_NR_set_tls) if defined(&__ARM_NR_set_tls);
    eval 'sub __ARM_NR_set_tls () {((0+0xf0000)+5);}' unless defined(&__ARM_NR_set_tls);
    eval 'sub SYS_set_tls () { &__ARM_NR_set_tls;}' unless defined(&SYS_set_tls);
    undef(&__NR_time) if defined(&__NR_time);
    undef(&SYS_time) if defined(&SYS_time);
    undef(&__NR_umount) if defined(&__NR_umount);
    undef(&SYS_umount) if defined(&SYS_umount);
    undef(&__NR_stime) if defined(&__NR_stime);
    undef(&SYS_stime) if defined(&SYS_stime);
    undef(&__NR_alarm) if defined(&__NR_alarm);
    undef(&SYS_alarm) if defined(&SYS_alarm);
    undef(&__NR_utime) if defined(&__NR_utime);
    undef(&SYS_utime) if defined(&SYS_utime);
    undef(&__NR_getrlimit) if defined(&__NR_getrlimit);
    undef(&SYS_getrlimit) if defined(&SYS_getrlimit);
    undef(&__NR_select) if defined(&__NR_select);
    undef(&SYS_select) if defined(&SYS_select);
    undef(&__NR_readdir) if defined(&__NR_readdir);
    undef(&SYS_readdir) if defined(&SYS_readdir);
    undef(&__NR_mmap) if defined(&__NR_mmap);
    undef(&SYS_mmap) if defined(&SYS_mmap);
    undef(&__NR_socketcall) if defined(&__NR_socketcall);
    undef(&SYS_socketcall) if defined(&SYS_socketcall);
    undef(&__NR_syscall) if defined(&__NR_syscall);
    undef(&SYS_syscall) if defined(&SYS_syscall);
    undef(&__NR_ipc) if defined(&__NR_ipc);
    undef(&SYS_ipc) if defined(&SYS_ipc);
}
1;
